/**
 * TrueReality - N64/macros.c
 * Copyright (C) 1998, 1999 Niki W. Waibel
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 * Information about me (the author):
 *   Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
 *   niki.waibel@gmx.net
**/





#include "macros.h"





/**
*
* The next global struct is used for statistic stuff (if it is turned on).
*
**/

#ifdef STATISTICS
        
        struct tr_statistic statistic;

        const char *tr_statistic_name[] =
        {
                "rs4300i_reserved",
                "rs4300i_invalid",
                "rs4300i_special",
                "rs4300i_regimm",
                "rs4300i_j",
                "rs4300i_jal",
                "rs4300i_beq",
                "rs4300i_bne",
                "rs4300i_blez",
                "rs4300i_bgtz",
                "rs4300i_addi",
                "rs4300i_addiu",
                "rs4300i_slti",
                "rs4300i_sltiu",
                "rs4300i_andi",
                "rs4300i_ori",
                "rs4300i_xori",
                "rs4300i_lui",
                "rs4300i_cop0",
                "rs4300i_cop1",
                "rs4300i_cop2",
                "rs4300i_beql",
                "rs4300i_bnel",
                "rs4300i_blezl",
                "rs4300i_bgtzl",
                "rs4300i_daddi",
                "rs4300i_daddiu",
                "rs4300i_ldl",
                "rs4300i_ldr",
                "rs4300i_lb",
                "rs4300i_lh",
                "rs4300i_lwl",
                "rs4300i_lw",
                "rs4300i_lbu",
                "rs4300i_lhu",
                "rs4300i_lwr",
                "rs4300i_lwu",
                "rs4300i_sb",
                "rs4300i_sh",
                "rs4300i_swl",
                "rs4300i_sw",
                "rs4300i_sdl",
                "rs4300i_sdr",
                "rs4300i_swr",
                "rs4300i_cache",
                "rs4300i_ll",
                "rs4300i_lwc1",
                "rs4300i_lwc2",
                "rs4300i_lld",
                "rs4300i_ldc1",
                "rs4300i_ldc2",
                "rs4300i_ld",
                "rs4300i_sc",
                "rs4300i_swc1",
                "rs4300i_swc2",
                "rs4300i_scd",
                "rs4300i_sdc1",
                "rs4300i_sdc2",
                "rs4300i_sd",
                "rs4300i_special_sll",
                "rs4300i_special_srl",
                "rs4300i_special_sra",
                "rs4300i_special_sllv",
                "rs4300i_special_srlv",
                "rs4300i_special_srav",
                "rs4300i_special_jr",
                "rs4300i_special_jalr",
                "rs4300i_special_syscall",
                "rs4300i_special_break",
                "rs4300i_special_sync",
                "rs4300i_special_mfhi",
                "rs4300i_special_mthi",
                "rs4300i_special_mflo",
                "rs4300i_special_mtlo",
                "rs4300i_special_dsllv",
                "rs4300i_special_dsrlv",
                "rs4300i_special_dsrav",
                "rs4300i_special_mult",
                "rs4300i_special_multu",
                "rs4300i_special_div",
                "rs4300i_special_divu",
                "rs4300i_special_dmult",
                "rs4300i_special_dmultu",
                "rs4300i_special_ddiv",
                "rs4300i_special_ddivu",
                "rs4300i_special_add",
                "rs4300i_special_addu",
                "rs4300i_special_sub",
                "rs4300i_special_subu",
                "rs4300i_special_and",
                "rs4300i_special_or",
                "rs4300i_special_xor",
                "rs4300i_special_nor",
                "rs4300i_special_slt",
                "rs4300i_special_sltu",
                "rs4300i_special_dadd",
                "rs4300i_special_daddu",
                "rs4300i_special_dsub",
                "rs4300i_special_dsubu",
                "rs4300i_special_tge",
                "rs4300i_special_tgeu",
                "rs4300i_special_tlt",
                "rs4300i_special_tltu",
                "rs4300i_special_teq",
                "rs4300i_special_tne",
                "rs4300i_special_dsll",
                "rs4300i_special_dsrl",
                "rs4300i_special_dsra",
                "rs4300i_special_dsll32",
                "rs4300i_special_dsrl32",
                "rs4300i_special_dsra32",
                "rs4300i_regimm_bltz",
                "rs4300i_regimm_bgez",
                "rs4300i_regimm_bltzl",
                "rs4300i_regimm_bgezl",
                "rs4300i_regimm_tgei",
                "rs4300i_regimm_tgeiu",
                "rs4300i_regimm_tlti",
                "rs4300i_regimm_tltiu",
                "rs4300i_regimm_teqi",
                "rs4300i_regimm_tnei",
                "rs4300i_regimm_bltzal",
                "rs4300i_regimm_bgezal",
                "rs4300i_regimm_bltzall",
                "rs4300i_regimm_bgezall",
                "rs4300i_cop0_rs_mf",
                "rs4300i_cop0_rs_dmf",
                "rs4300i_cop0_rs_cf",
                "rs4300i_cop0_rs_mt",
                "rs4300i_cop0_rs_dmt",
                "rs4300i_cop0_rs_ct",
                "rs4300i_cop0_rs_bc",
                "rs4300i_cop0_rs_co",
                "rs4300i_cop0_rt_bcf",
                "rs4300i_cop0_rt_bct",
                "rs4300i_cop0_rt_bcfl",
                "rs4300i_cop0_rt_bctl",
                "rs4300i_cop0_tlbr",
                "rs4300i_cop0_tlbwi",
                "rs4300i_cop0_tlbwr",
                "rs4300i_cop0_tlbp",
                "rs4300i_cop0_eret",
                "rs4300i_cop1_rs_mf",
                "rs4300i_cop1_rs_dmf",
                "rs4300i_cop1_rs_cf",
                "rs4300i_cop1_rs_mt",
                "rs4300i_cop1_rs_dmt",
                "rs4300i_cop1_rs_ct",
                "rs4300i_cop1_rs_bc",
                "rs4300i_cop1_rs_co",
                "rs4300i_cop1_rt_bcf",
                "rs4300i_cop1_rt_bct",
                "rs4300i_cop1_rt_bcfl",
                "rs4300i_cop1_rt_bctl",
                "rs4300i_cop1_add",
                "rs4300i_cop1_sub",
                "rs4300i_cop1_mul",
                "rs4300i_cop1_div",
                "rs4300i_cop1_sqrt",
                "rs4300i_cop1_abs",
                "rs4300i_cop1_mov",
                "rs4300i_cop1_neg",
                "rs4300i_cop1_roundl",
                "rs4300i_cop1_truncl",
                "rs4300i_cop1_ceill",
                "rs4300i_cop1_floorl",
                "rs4300i_cop1_roundw",
                "rs4300i_cop1_truncw",
                "rs4300i_cop1_ceilw",
                "rs4300i_cop1_floorw",
                "rs4300i_cop1_cvts",
                "rs4300i_cop1_cvtd",
                "rs4300i_cop1_cvtw",
                "rs4300i_cop1_cvtl",
                "rs4300i_cop1_c",
                "rs4300i_cop2_rs_not_implemented"
        };

#endif

