/**
 * TrueReality - N64/macros.h
 * Copyright (C) 1998, 1999 Niki W. Waibel
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 * Information about me (the author):
 *   Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
 *   niki.waibel@gmx.net
**/





/*
*
* For statistic stuff if STATISTICS is defined:
*
* If you use STATISTIC_CALC(xxx) you have to put a "long xxx;" into
* the struct below.
* Put the macro at the end of each routine you want to have statistics.
*
* ATTENSION: overflow is not handled!!!
* ATTENSION: STATISTIC_PRINT_TOP(n): if more values have the same contents: bug
*
*/

#ifdef STATISTICS

        #define STATISTIC_CALC(var) ((statistic.##var)++);

        #define STATISTIC_RESET                                                         \
                {                                                                       \
                        int i;                                                          \
                                                                                        \
                        for(i=0; i<sizeof(struct tr_statistic)/sizeof(long); i++)       \
                        {                                                               \
                                ((long *)(&statistic))[i] = 0;                          \
                        }                                                               \
                }

        #define STATISTIC_PRINT_ALL                                                     \
                {                                                                       \
                        int  i;                                                         \
                                                                                        \
                        for(i=0; i<sizeof(struct tr_statistic)/sizeof(long); i++)       \
                        {                                                               \
                                printf("STATISTICS: $%8lx (%8ld) - %s\n",               \
                                        ((long *)(&statistic))[i],                      \
                                        ((long *)(&statistic))[i],                      \
                                        tr_statistic_name[i]                            \
                                        );                                              \
                        }                                                               \
                }

        #define STATISTIC_PRINT_TOP(n)                                                  \
                {                                                                       \
                        long found[n];                                                  \
                        int  elem = sizeof(struct tr_statistic)/sizeof(long);           \
                        int  i, j, k;                                                   \
                        long curr, max;                                                 \
                                                                                        \
                        for(i=0; i<(n); i++)                                            \
                        {                                                               \
                                max = 0;                                                \
                                found[i] = 0;                                           \
                                                                                        \
                                for(j=0; j<elem; j++)                                   \
                                {                                                       \
                                        for(k=0; k<i; k++)                              \
                                        {                                               \
                                                if(found[k] == j)                       \
                                                {                                       \
                                                        j++;                            \
                                                        k = -1;                         \
                                                }                                       \
                                        }                                               \
                                                                                        \
                                        curr = ((long *)(&statistic))[j];               \
                                        if(curr > max)                                  \
                                        {                                               \
                                                max = curr;                             \
                                                found[i] = j;                           \
                                        }                                               \
                                }                                                       \
                                printf("STATISTICS: #%3d - $%8lx - %s\n",               \
                                        i+1,                                            \
                                        max,                                            \
                                        tr_statistic_name[found[i]] );                  \
                        }                                                               \
                }


        struct tr_statistic
        {
                long rs4300i_reserved;
                long rs4300i_invalid;
                long rs4300i_special;
                long rs4300i_regimm;
                long rs4300i_j;
                long rs4300i_jal;
                long rs4300i_beq;
                long rs4300i_bne;
                long rs4300i_blez;
                long rs4300i_bgtz;
                long rs4300i_addi;
                long rs4300i_addiu;
                long rs4300i_slti;
                long rs4300i_sltiu;
                long rs4300i_andi;
                long rs4300i_ori;
                long rs4300i_xori;
                long rs4300i_lui;
                long rs4300i_cop0;
                long rs4300i_cop1;
                long rs4300i_cop2;
                long rs4300i_beql;
                long rs4300i_bnel;
                long rs4300i_blezl;
                long rs4300i_bgtzl;
                long rs4300i_daddi;
                long rs4300i_daddiu;
                long rs4300i_ldl;
                long rs4300i_ldr;
                long rs4300i_lb;
                long rs4300i_lh;
                long rs4300i_lwl;
                long rs4300i_lw;
                long rs4300i_lbu;
                long rs4300i_lhu;
                long rs4300i_lwr;
                long rs4300i_lwu;
                long rs4300i_sb;
                long rs4300i_sh;
                long rs4300i_swl;
                long rs4300i_sw;
                long rs4300i_sdl;
                long rs4300i_sdr;
                long rs4300i_swr;
                long rs4300i_cache;
                long rs4300i_ll;
                long rs4300i_lwc1;
                long rs4300i_lwc2;
                long rs4300i_lld;
                long rs4300i_ldc1;
                long rs4300i_ldc2;
                long rs4300i_ld;
                long rs4300i_sc;
                long rs4300i_swc1;
                long rs4300i_swc2;
                long rs4300i_scd;
                long rs4300i_sdc1;
                long rs4300i_sdc2;
                long rs4300i_sd;
                long rs4300i_special_sll;
                long rs4300i_special_srl;
                long rs4300i_special_sra;
                long rs4300i_special_sllv;
                long rs4300i_special_srlv;
                long rs4300i_special_srav;
                long rs4300i_special_jr;
                long rs4300i_special_jalr;
                long rs4300i_special_syscall;
                long rs4300i_special_break;
                long rs4300i_special_sync;
                long rs4300i_special_mfhi;
                long rs4300i_special_mthi;
                long rs4300i_special_mflo;
                long rs4300i_special_mtlo;
                long rs4300i_special_dsllv;
                long rs4300i_special_dsrlv;
                long rs4300i_special_dsrav;
                long rs4300i_special_mult;
                long rs4300i_special_multu;
                long rs4300i_special_div;
                long rs4300i_special_divu;
                long rs4300i_special_dmult;
                long rs4300i_special_dmultu;
                long rs4300i_special_ddiv;
                long rs4300i_special_ddivu;
                long rs4300i_special_add;
                long rs4300i_special_addu;
                long rs4300i_special_sub;
                long rs4300i_special_subu;
                long rs4300i_special_and;
                long rs4300i_special_or;
                long rs4300i_special_xor;
                long rs4300i_special_nor;
                long rs4300i_special_slt;
                long rs4300i_special_sltu;
                long rs4300i_special_dadd;
                long rs4300i_special_daddu;
                long rs4300i_special_dsub;
                long rs4300i_special_dsubu;
                long rs4300i_special_tge;
                long rs4300i_special_tgeu;
                long rs4300i_special_tlt;
                long rs4300i_special_tltu;
                long rs4300i_special_teq;
                long rs4300i_special_tne;
                long rs4300i_special_dsll;
                long rs4300i_special_dsrl;
                long rs4300i_special_dsra;
                long rs4300i_special_dsll32;
                long rs4300i_special_dsrl32;
                long rs4300i_special_dsra32;
                long rs4300i_regimm_bltz;
                long rs4300i_regimm_bgez;
                long rs4300i_regimm_bltzl;
                long rs4300i_regimm_bgezl;
                long rs4300i_regimm_tgei;
                long rs4300i_regimm_tgeiu;
                long rs4300i_regimm_tlti;
                long rs4300i_regimm_tltiu;
                long rs4300i_regimm_teqi;
                long rs4300i_regimm_tnei;
                long rs4300i_regimm_bltzal;
                long rs4300i_regimm_bgezal;
                long rs4300i_regimm_bltzall;
                long rs4300i_regimm_bgezall;
                long rs4300i_cop0_rs_mf;
                long rs4300i_cop0_rs_dmf;
                long rs4300i_cop0_rs_cf;
                long rs4300i_cop0_rs_mt;
                long rs4300i_cop0_rs_dmt;
                long rs4300i_cop0_rs_ct;
                long rs4300i_cop0_rs_bc;
                long rs4300i_cop0_rs_co;
                long rs4300i_cop0_rt_bcf;
                long rs4300i_cop0_rt_bct;
                long rs4300i_cop0_rt_bcfl;
                long rs4300i_cop0_rt_bctl;
                long rs4300i_cop0_tlbr;
                long rs4300i_cop0_tlbwi;
                long rs4300i_cop0_tlbwr;
                long rs4300i_cop0_tlbp;
                long rs4300i_cop0_eret;
                long rs4300i_cop1_rs_mf;
                long rs4300i_cop1_rs_dmf;
                long rs4300i_cop1_rs_cf;
                long rs4300i_cop1_rs_mt;
                long rs4300i_cop1_rs_dmt;
                long rs4300i_cop1_rs_ct;
                long rs4300i_cop1_rs_bc;
                long rs4300i_cop1_rs_co;
                long rs4300i_cop1_rt_bcf;
                long rs4300i_cop1_rt_bct;
                long rs4300i_cop1_rt_bcfl;
                long rs4300i_cop1_rt_bctl;
                long rs4300i_cop1_add;
                long rs4300i_cop1_sub;
                long rs4300i_cop1_mul;
                long rs4300i_cop1_div;
                long rs4300i_cop1_sqrt;
                long rs4300i_cop1_abs;
                long rs4300i_cop1_mov;
                long rs4300i_cop1_neg;
                long rs4300i_cop1_roundl;
                long rs4300i_cop1_truncl;
                long rs4300i_cop1_ceill;
                long rs4300i_cop1_floorl;
                long rs4300i_cop1_roundw;
                long rs4300i_cop1_truncw;
                long rs4300i_cop1_ceilw;
                long rs4300i_cop1_floorw;
                long rs4300i_cop1_cvts;
                long rs4300i_cop1_cvtd;
                long rs4300i_cop1_cvtw;
                long rs4300i_cop1_cvtl;
                long rs4300i_cop1_c;
                long rs4300i_cop2_rs_not_implemented;
        };

        extern struct tr_statistic statistic;
        extern const char *tr_statistic_name[];

#else

        #define STATISTIC_CALC(var)
        #define STATISTIC_RESET
        #define STATISTIC_PRINT_ALL
        #define STATISTIC_PRINT_TOP(n)

#endif

