/**
 * TrueReality - N64/rsp_registers.h
 * Copyright (C) 1998, 1999 Niki W. Waibel
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 * Information about me (the author):
 *   Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
 *   niki.waibel@gmx.net
**/





/* every 'export' in this file resides in 'rsp.c' */
/* this file could also be named as 'rsp_export.h' */





#define __RSP_REGISTERS_H


#ifndef __TYPE_SIZES_H
        #include "type_sizes.h"
#endif





/* all "real" values are in rsp.c */

/* rsp registers */

struct rsp_reg
{
        
        sWORD  r[32];           /* general purpose registers */

        sHWORD  v[32][8];       /* vector registers */
        sHWORD  v_src1[8];      /* dummy source 1 vector registers */
        sHWORD  v_src2[8];      /* dummy source 2 vector registers */
        sHWORD  dummy[8];      /* dummy source 2 vector registers */

        sHWORD  ah[8];          /* high portion of accu */
        sHWORD  al[8];          /* low  portion of accu */
        sHWORD  flag[4];        /* cop2 control registers */

        sHWORD  vrcph_result;       /* calculated by VRCPL - stored by VRCPH */
        sHWORD  vrcph_source;       /* used by VRCPL - stored by VRCPH */



        uWORD    pc_delay;   /* delayed program counter */
        int     delay;      /* this is for correct emulation of the 6 stage pipeline */
                            /* if(delay ==  0) { next instr is pc + 4 } */
                            /* if(delay ==  1) { next instr is delayed pc} */
                            /* if(delay == -1) { exec delayed pc} */
        
        uWORD    code;       /* current code (needed for speed) */
        int     halt;       /* if '!0' then stop execution */
        int     do_or_check_sthg; /* if '!0' then the rs4300i has to do or check sthg */
                            /* look at the defines that follow this struct */
        uWORD    count;      /* just for debugging */

}; /* struct rsp_reg */



/* rsp_reg.delay */

#define NO_RSP_DELAY    0
#define DO_RSP_DELAY    1
#define EXEC_RSP_DELAY  2





extern struct rsp_reg rsp_reg;





