#
# TrueReality - N64/cpu.c
# Copyright (C) 1998 Guenther Sohler
#
# This program is free software; you can redistribute it and/
# or modify it under the terms of the GNU General Public Li-
# cence as published by the Free Software Foundation; either
# version 2 of the Licence, or any later version.
#
# This program is distributed in the hope that it will be use-
# ful, but WITHOUT ANY WARRANTY; without even the implied war-
# ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public Licence for more details.
#
# You should have received a copy of the GNU General Public
# Licence along with this program; if not, write to the Free
# Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
# USA.
#
# Information about me (the author):
#   Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
#   niki.waibel@gmx.net
#
# Information the author of the assambler CPU core:
#   Guenther Sohler, Lerschen 1 6914 Hohenweiler - EUROPE
#   guenther.sohler@newlogic.at
#

a_rs4300i_cop0_rs_mf:GETDSTREG
	MOVL	CPR0_OFS(%EBX),%EDX
	GETTARGREG
	MOVL	%EDX,REG_OFS(%EBX)
	GOTONEXTCMD

a_rs4300i_cop0_rs_dmf:GETDSTREG
	MOVL	CPR0_OFS(%EBX),%EDX
	MOVL	CPR0_OFS(%EBX),%ECX
	GETTARGREG
	MOVL	%EDX,REG_OFS(%EBX)
	MOVL	%ECX,REG_OFS+4(%EBX)
	GOTONEXTCMD

a_rs4300i_cop0_rs_mt:GETDSTREG
	CMPL	$COMPARE,	%EBX
	JNZ	a_rs4300i_cop0_RS_MT1
	ANDL	$0xffff7fff,CPR0_OFS+CAUSE
a_rs4300i_cop0_RS_MT1:
	CMPL	$CAUSE,%EBX
	JNZ a_rs4300i_cop0_RS_MT2
	GETTARGREG
	MOVL	CPU_OFS(%EBX),%EDX
	ANDL	$0x300,%EDX
	MOVL	%EDX,CPR0_OFS+CAUSE(%EBX)
	GOTONEXTCMD
a_rs4300i_cop0_RS_MT2:
	GETTARGREG
	MOVL	REG_OFS(%EBX),%EDX
	GETDSTREG
	MOVL	%EDX,CPR0_OFS(%EBX)
	CMPL	$STATUS,%EBX
	JNZ	a_rs4300i_cop0_RS_MT3
	ORL	$RS4300I_CHECK_CPU_INTERRUPTS,DOSOMETHING
a_rs4300i_cop0_RS_MT3:
	GOTONEXTCMD

a_rs4300i_cop0_rs_dmt:GETDSTREG
	CMPL	$COMPARE,	%EBX
	JNZ	a_rs4300i_cop0_RS_DMT1
	ANDL	$0xffff7fff,CPR0_OFS+CAUSE
a_rs4300i_cop0_RS_DMT1:
	CMPL	$CAUSE,%EBX
	JNZ 	a_rs4300i_cop0_RS_DMT2
	ANDL	$0x300,%EDX
	MOVL	%EDX,REG_OFS(%EBX)
	GOTONEXTCMD
a_rs4300i_cop0_RS_DMT2:
	GETTARGREG
	MOVL	CPU_OFS(%EBX),%EDX
	MOVL	CPU_OFS+4(%EBX),%ECX
	GETDSTREG
	MOVL	%EDX,CPR0_OFS(%EBX)
	MOVL	%ECX,CPR0_OFS+4(%EBX)
	CMPL	$STATUS,%EBX
	JNZ	a_rs4300i_cop0_RS_DMT3
	ORL	$RS4300I_CHECK_CPU_INTERRUPTS,DOSOMETHING
a_rs4300i_cop0_RS_DMT3:
	GOTONEXTCMD


a_rs4300i_cop0_rs_cf:GETTARGREG
	MOVL	REG_OFS(%EBX),%EDX
	GETDSTREG
	MOVL	%EDX,CCR0_OFS(%EBX)
	GOTONEXTCMD

a_rs4300i_cop0_rs_ct:GETTARGREG
	MOVL	REG_OFS(%EBX),%EDX
	GETDSTREG
	MOVL	%EDX,CCR0_OFS(%EBX)
	GOTONEXTCMD

	
a_rs4300i_cop0_rs_bc:
	MOVL	%EAX,%EBX		#extract opcode   
	SHLL	$14,%EBX				  
	ANDL	$124,%EBX			          
	JMP	COP0_RT_OFS(%EBX)				  

a_rs4300i_cop0_rs_co:
	MOVL	%EAX,%EBX		#extract opcode   
	ANDL	$63,%EBX			          
	SHLL	$2,%EBX
	JMP	COP0_OFS(%EBX)				  

a_rs4300i_cop0_rt_bct:
a_rs4300i_cop0_rt_bcf:
a_rs4300i_cop0_rt_bcfl:
a_rs4300i_cop0_rt_bctl:JMP	CPU_UNDEF

a_rs4300i_cop0_eret:BT	$2,CPR0_OFS+STATUS
	JNZ	a_rs4300i_cop0_ERET1
	MOVL	CPR0_OFS+ERROREPC,%ECX
	MOVL	%ECX,PC
	SUBL	$4,PC
	ANDL	$0xfffffffb,CPR0_OFS+STATUS
	JMP	a_rs4300i_cop0_ERET2
a_rs4300i_cop0_ERET1:
	MOVL	CPR0_OFS+EPC,%ECX
	MOVL	%ECX,PC
	SUBL	$4,PC
	ANDL	$0xfffffffd,CPR0_OFS+STATUS
a_rs4300i_cop0_ERET2:
	MOVL	$0,DELAY
	MOVL	$0,LL_BIT
	GOTONEXTCMD

a_rs4300i_cop0_tlbr:
a_rs4300i_cop0_tlbwi:
a_rs4300i_cop0_tlbp:
	JMP CPU_UNDEF
