#
# TrueReality - N64/cpu.c
# Copyright (C) 1998 Guenther Sohler
#
# This program is free software; you can redistribute it and/
# or modify it under the terms of the GNU General Public Li-
# cence as published by the Free Software Foundation; either
# version 2 of the Licence, or any later version.
#
# This program is distributed in the hope that it will be use-
# ful, but WITHOUT ANY WARRANTY; without even the implied war-
# ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public Licence for more details.
#
# You should have received a copy of the GNU General Public
# Licence along with this program; if not, write to the Free
# Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
# USA.
#
# Information about me (the author):
#   Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
#   niki.waibel@gmx.net
#
# Information the author of the assambler CPU core:
#   Guenther Sohler, Lerschen 1 6914 Hohenweiler - EUROPE
#   guenther.sohler@newlogic.at
#

#some problems with  roundl & co, 8 instr. 

.globl a_rs4300i_cop1_c


a_rs4300i_cop1_add:
	BTL	$21,%EAX
	JC	a_rs4300i_cop1_add1
	LOADFTARGWORDFPU
	LOADFSRCWORDFPU
	FADDP
	STOREFDSTWORDFPU
	GOTONEXTCMD
a_rs4300i_cop1_add1:
	LOADFTARGDWORDFPU
	LOADFSRCDWORDFPU
	FADDP
	STOREFDSTDWORDFPU
	GOTONEXTCMD	

a_rs4300i_cop1_sub:
	BTL	$21,%EAX
	JC	a_rs4300i_cop1_sub1
	LOADFTARGWORDFPU
	LOADFSRCWORDFPU
	FSUBP
	STOREFDSTWORDFPU
	GOTONEXTCMD
a_rs4300i_cop1_sub1:
	LOADFTARGDWORDFPU
	LOADFSRCDWORDFPU
	FSUBP
	STOREFDSTDWORDFPU
	GOTONEXTCMD	


a_rs4300i_cop1_mul:
	BTL	$21,%EAX
	JC	a_rs4300i_cop1_mul1
	LOADFTARGWORDFPU
	LOADFSRCWORDFPU
	FMULP
	STOREFDSTWORDFPU
	GOTONEXTCMD
a_rs4300i_cop1_mul1:
	LOADFTARGDWORDFPU
	LOADFSRCDWORDFPU
	FMULP
	STOREFDSTDWORDFPU
	GOTONEXTCMD	

a_rs4300i_cop1_div:
	BTL	$21,%EAX
	JC	a_rs4300i_cop1_div1
	LOADFTARGWORDFPU
	LOADFSRCWORDFPU
	FDIVP
	STOREFDSTWORDFPU
	GOTONEXTCMD
a_rs4300i_cop1_div1:
	LOADFTARGDWORDFPU
	LOADFSRCDWORDFPU
	FDIVP
	STOREFDSTDWORDFPU
	GOTONEXTCMD	

a_rs4300i_cop1_sqrt:
	BTL	$21,%EAX
	JC	a_rs4300i_cop1_sqrt1
	LOADFSRCWORDFPU
	FSQRT
	STOREFDSTWORDFPU
	GOTONEXTCMD
a_rs4300i_cop1_sqrt1:
	LOADFSRCDWORDFPU
	FSQRT
	STOREFDSTDWORDFPU
	GOTONEXTCMD	

a_rs4300i_cop1_abs:
	BTL	$21,%EAX
	JC	a_rs4300i_cop1_abs1
	LOADFSRCWORDFPU
	FABS
	STOREFDSTWORDFPU
	GOTONEXTCMD
a_rs4300i_cop1_abs1:
	LOADFSRCDWORDFPU
	FABS
	STOREFDSTDWORDFPU
	GOTONEXTCMD	

a_rs4300i_cop1_mov:
	BTL	$21,%EAX
	JC	a_rs4300i_cop1_mov1
	LOADFSRCWORDFPU
	STOREFDSTWORDFPU
	GOTONEXTCMD
a_rs4300i_cop1_mov1:
	LOADFSRCDWORDFPU
	STOREFDSTDWORDFPU
	GOTONEXTCMD	

a_rs4300i_cop1_neg:
	BTL	$21,%EAX
	JC	a_rs4300i_cop1_neg1
	LOADFSRCWORDFPU
	FCHS
	STOREFDSTWORDFPU
	GOTONEXTCMD
a_rs4300i_cop1_neg1:
	LOADFSRCDWORDFPU
	FCHS
	STOREFDSTDWORDFPU
	GOTONEXTCMD	


a_rs4300i_cop1_roundl:
a_rs4300i_cop1_roundw:
	FNSTCW	-4(%ESP)
	FNSTCW	-8(%ESP)
	MOVB	$0,-3(%ESP)
	FLDCW	-4(%ESP)
	BTL	$21,%EAX
	JC	a_rs4300i_cop1_roundw1
	LOADFSRCWORDFPU
	STOREFDSTIDWORDFPU
	FLDCW	-8(%ESP)
	GOTONEXTCMD
a_rs4300i_cop1_roundw1:
	LOADFSRCDWORDFPU
	STOREFDSTIDWORDFPU
	FLDCW	-8(%ESP)
	GOTONEXTCMD


a_rs4300i_cop1_truncl:
a_rs4300i_cop1_truncw:
	FNSTCW	-4(%ESP)
	FNSTCW	-8(%ESP)
	MOVB	$12,-3(%ESP)
	FLDCW	-4(%ESP)
	BTL	$21,%EAX
	JC	a_rs4300i_cop1_truncw1
	LOADFSRCWORDFPU
	STOREFDSTIDWORDFPU
	FCLEX
	FLDCW	-8(%ESP)
	GOTONEXTCMD
a_rs4300i_cop1_truncw1:
	LOADFSRCDWORDFPU
	STOREFDSTIDWORDFPU
	FCLEX
	FLDCW	-8(%ESP)
	GOTONEXTCMD

a_rs4300i_cop1_ceill:
a_rs4300i_cop1_ceilw:
	FNSTCW	-4(%ESP)
	FNSTCW	-8(%ESP)
	MOVB	$8,-3(%ESP)
#	FLDCW	-4(%ESP)
	BTL	$21,%EAX
	JC	a_rs4300i_cop1_ceilw1
	LOADFSRCWORDFPU
	STOREFDSTIDWORDFPU
#	FLDCW	-8(%ESP)
	GOTONEXTCMD
a_rs4300i_cop1_ceilw1:
	LOADFSRCDWORDFPU
	STOREFDSTIDWORDFPU
#	FLDCW	-8(%ESP)
	GOTONEXTCMD


a_rs4300i_cop1_floorl:
a_rs4300i_cop1_floorw:
	FNSTCW	-4(%ESP)
	FNSTCW	-8(%ESP)
	MOVB	$4,-3(%ESP)
	FLDCW	-4(%ESP)
	BTL	$21,%EAX
	JC	a_rs4300i_cop1_floorw1
	LOADFSRCWORDFPU
	STOREFDSTIDWORDFPU
	FLDCW	-8(%ESP)
	GOTONEXTCMD
a_rs4300i_cop1_floorw1:
	LOADFSRCDWORDFPU
	STOREFDSTIDWORDFPU
	FLDCW	-8(%ESP)
	GOTONEXTCMD


a_rs4300i_cop1_cvts:
	BTL	$23,%EAX
	JC	a_rs4300i_cop1_cvts2
	BTL	$21,%EAX
	JC	a_rs4300i_cop1_cvts1
	LOADFSRCWORDFPU
	JMP	a_rs4300i_cop1_cvts4
a_rs4300i_cop1_cvts1:
	LOADFSRCDWORDFPU
	JMP	a_rs4300i_cop1_cvts4
a_rs4300i_cop1_cvts2:
	BTL	$21,%EAX
	JC	a_rs4300i_cop1_cvts3
a_rs4300i_cop1_cvts3:
	LOADFSRCIWORDFPU
	JMP	a_rs4300i_cop1_cvts4
	LOADFSRCIDWORDFPU
a_rs4300i_cop1_cvts4:
	STOREFDSTWORDFPU
	GOTONEXTCMD


a_rs4300i_cop1_cvtd:
	BTL	$23,%EAX
	JC	a_rs4300i_cop1_cvtd2
	BTL	$21,%EAX
	JC	a_rs4300i_cop1_cvtd1
	LOADFSRCWORDFPU
	JMP	a_rs4300i_cop1_cvtd4
a_rs4300i_cop1_cvtd1:
	LOADFSRCDWORDFPU
	JMP	a_rs4300i_cop1_cvtd4
a_rs4300i_cop1_cvtd2:
	BTL	$21,%EAX
	JC	a_rs4300i_cop1_cvtd3
a_rs4300i_cop1_cvtd3:
	LOADFSRCIWORDFPU
	JMP	a_rs4300i_cop1_cvtd4
	LOADFSRCIDWORDFPU
a_rs4300i_cop1_cvtd4:
	STOREFDSTDWORDFPU
	GOTONEXTCMD


a_rs4300i_cop1_cvtw:
	BTL	$23,%EAX
	JC	a_rs4300i_cop1_cvtw2
	BTL	$21,%EAX
	JC	a_rs4300i_cop1_cvtw1
	LOADFSRCWORDFPU
	JMP	a_rs4300i_cop1_cvtw4
a_rs4300i_cop1_cvtw1:
	LOADFSRCDWORDFPU
	JMP	a_rs4300i_cop1_cvtw4
a_rs4300i_cop1_cvtw2:
	BTL	$21,%EAX
	JC	a_rs4300i_cop1_cvtw3
a_rs4300i_cop1_cvtw3:
	LOADFSRCIWORDFPU
	JMP	a_rs4300i_cop1_cvtw4
	LOADFSRCIDWORDFPU
a_rs4300i_cop1_cvtw4:
	STOREFDSTIWORDFPU
	GOTONEXTCMD

a_rs4300i_cop1_cvtl:
	BTL	$23,%EAX
	JC	a_rs4300i_cop1_cvtl2
	BTL	$21,%EAX
	JC	a_rs4300i_cop1_cvtl1
	LOADFSRCWORDFPU
	JMP	a_rs4300i_cop1_cvtl4
a_rs4300i_cop1_cvtl1:
	LOADFSRCDWORDFPU
	JMP	a_rs4300i_cop1_cvtl4
a_rs4300i_cop1_cvtl2:
	BTL	$21,%EAX
	JC	a_rs4300i_cop1_cvtl3
a_rs4300i_cop1_cvtl3:
	LOADFSRCIWORDFPU
	JMP	a_rs4300i_cop1_cvtl4
	LOADFSRCIDWORDFPU
a_rs4300i_cop1_cvtl4:
	STOREFDSTIWORDFPU
	GOTONEXTCMD


a_rs4300i_cop1_c:
	BTL	$21,%EAX
	JC	a_rs4300i_cop1_c1
	LOADFSRCWORDFPU
	LOADFTARGWORDFPU

	JMP	a_rs4300i_cop1_c2
a_rs4300i_cop1_c1:
	LOADFSRCDWORDFPU
	LOADFTARGDWORDFPU
a_rs4300i_cop1_c2:
	MOVL	%EAX,%EBX
	ANDL	$15,%EBX
	SHLL	$2,%EBX
	FCOMPP
	FNSTSW	%AX
	JMP	COP1_CTBL(%EBX)

a_rs4300i_cop1_cueq:
a_rs4300i_cop1_cngt:
a_rs4300i_cop1_cres:
	MOVL	$1,HALT
	GOTONEXTCMD
a_rs4300i_cop1_cf:
	MOVB	$0,%AL
	JMP	a_rs4300i_cop1_cend
a_rs4300i_cop1_ceq:
	ANDB	$69,%AL
	CMPB	$64,%AL
	SETE	%AL
	JMP	a_rs4300i_cop1_cend
a_rs4300i_cop1_clt:
	ANDB	$5,%AL
	SETNE	%AL
	JMP	a_rs4300i_cop1_cend
a_rs4300i_cop1_cnge:
a_rs4300i_cop1_cle:
	ANDB	$69,%AL
	SETNE	%AL
	JMP	a_rs4300i_cop1_cend

a_rs4300i_cop1_cend:
	CMP	$0,%AL
	JE	a_rs4300i_cop1_cend1
	  ORL	$0x00800000,CCR1_OFS+248
	  GOTONEXTCMD
a_rs4300i_cop1_cend1:ANDL $0xff7fffff,CCR1_OFS+248
	GOTONEXTCMD


a_rs4300i_cop1_rs_mf:
	LOADFSRCWORD
	GETTARGREG
	MOVL	%EDX,REG_OFS(%EBX)
	SARL	$31,%EDX
	MOVL	%EDX,REG_OFS+4(%EBX)
	GOTONEXTCMD

a_rs4300i_cop1_rs_dmf:
	LOADFSRCWORD
	MOVL	%EBX,%EDI
	GETTARGREG
	MOVL	%EDX,REG_OFS(%EBX)
	MOVL	%EDI,REG_OFS+4(%EBX)
	GOTONEXTCMD

a_rs4300i_cop1_rs_mt:
	GETTARGREG
	MOVL	REG_OFS(%EBX),%EDX
	STOREFSRCWORD
	GOTONEXTCMD

a_rs4300i_cop1_rs_dmt:
	GETTARGREG
	MOVL	REG_OFS(%EBX),%EDX
	MOVL	REG_OFS+4(%EBX),%EBX
	STOREFSRCDWORD	
	GOTONEXTCMD

a_rs4300i_cop1_rs_cf:GETTARGREG
	MOVL	REG_OFS(%EBX),%EDX
	GETDSTREG
	MOVL	%EDX,CCR1_OFS(%EBX)
	GOTONEXTCMD

a_rs4300i_cop1_rs_ct:
	GETDSTREG
	MOVL	CCR1_OFS(%EBX),%EDX
	GETTARGREG
	MOVL	%EDX,REG_OFS(%EBX)
	GOTONEXTCMD

	
a_rs4300i_cop1_rs_bc:
	MOVL	%EAX,%EBX		#extract opcode   
	SHRL	$14,%EBX				  
	ANDL	$124,%EBX			          
	JMP	COP1_RT_OFS(%EBX)				  

a_rs4300i_cop1_rs_co:
	MOVL	%EAX,%EBX		#extract opcode   
	SHLL	$2,%EBX
	ANDL	$252,%EBX			          
	JMP	COP1_OFS(%EBX)				  

a_rs4300i_cop1_rt_bcf:BT	$23,CCR1_OFS+248
	JC	a_rs4300i_cop1_RT_BCF1
	GETINDEX
	SHLL 	$2,%EBX
	ADDL	PC,%EBX
	ADDL	$4,%EBX
	MOVL	%EBX,PC_DELAY
	MOVL	$1,DELAY
a_rs4300i_cop1_RT_BCF1:GOTONEXTCMD

a_rs4300i_cop1_rt_bct:BT	$23,CCR1_OFS+248
	JNC	a_rs4300i_cop1_RT_BCT1
	GETINDEX
	SHLL 	$2,%EBX
	ADDL	PC,%EBX
	ADDL	$4,%EBX
	MOVL	%EBX,PC_DELAY
	MOVL	$1,DELAY
a_rs4300i_cop1_RT_BCT1:GOTONEXTCMD


a_rs4300i_cop1_rt_bcfl:
	BT	$23,CCR1_OFS+248
	JC	a_rs4300i_cop1_RT_BCFL1
	GETINDEX
	SHLL 	$2,%EBX
	ADDL	PC,%EBX
	ADDL	$4,%EBX
	MOVL	%EBX,PC_DELAY
	MOVL	$1,DELAY
	GOTONEXTCMD
a_rs4300i_cop1_RT_BCFL1:
	ADDL	$4,PC
	GOTONEXTCMD

a_rs4300i_cop1_rt_bctl:BT	$23,CCR1_OFS+248
	JNC	a_rs4300i_cop1_RT_BCTL1
	GETINDEX
	SHLL 	$2,%EBX
	ADDL	PC,%EBX
	ADDL	$4,%EBX
	MOVL	%EBX,PC_DELAY
	MOVL	$1,DELAY
	GOTONEXTCMD
a_rs4300i_cop1_RT_BCTL1:
	ADDL	$4,PC
	GOTONEXTCMD



