#
# TrueReality - N64/cpu_asm.S
# Copyright (C) 1998 Guenther Sohler
#
# This program is free software; you can redistribute it and/
# or modify it under the terms of the GNU General Public Li-
# cence as published by the Free Software Foundation; either
# version 2 of the Licence, or any later version.
#
# This program is distributed in the hope that it will be use-
# ful, but WITHOUT ANY WARRANTY; without even the implied war-
# ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public Licence for more details.
#
# You should have received a copy of the GNU General Public
# Licence along with this program; if not, write to the Free
# Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
# USA.
#
# Information about me (the author):
#   Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
#   niki.waibel@gmx.net
#
# Information the author of the assambler CPU core:
#   Guenther Sohler, Lerschen 1 6914 Hohenweiler - EUROPE
#   guenther.sohler@newlogic.at
#


#COP2
#correct cop1 compare
#code tlb things
#overgflow exceptions
#verify some functions
#lwr,lwl and so on are not ideal due to the fact that shift right by 32 bit does not clear the register

#include "macros.S"
#include "cop0_asm.S"
#include "cop1_asm.S"
.section .data

.globl rs4300i_doCode
.globl cpu_asm_init

.align 32
CPU_OFS: .fill 256

SPEC_OFS: .fill 256

REGIMM_OFS: .fill 128

COP0_OFS: .fill 256

COP0_RS_OFS: .fill 128

COP0_RT_OFS: .fill 128

COP1_OFS: .fill 256

COP1_RS_OFS: .fill 128

COP1_RT_OFS: .fill 128

COP1_CTBL: .fill 64

COP2_OFS: .fill 256

COP2_RS_OFS: .fill 128

COP2_RT_OFS: .fill 128

cpu_asm_init:   
	MOVL    $a_rs4300i_special	,(CPU_OFS+0)
	MOVL    $a_rs4300i_regimm	,(CPU_OFS+4)
	MOVL    $rs4300i_j		,(CPU_OFS+8)    # SKIPTIME: fix it (niki)
	MOVL    $a_rs4300i_jal		,(CPU_OFS+12)
	MOVL    $rs4300i_beq		,(CPU_OFS+16)   # SKIPTIMEC: fix it (niki)
	MOVL    $rs4300i_bne		,(CPU_OFS+20)   # SKIPTIMEC: fix it (niki)
	MOVL    $rs4300i_blez		,(CPU_OFS+24)   # SKIPTIMEC: fix it (niki)
	MOVL    $rs4300i_bgtz		,(CPU_OFS+28)   # SKIPTIMEC: fix it (niki)
	MOVL    $a_rs4300i_addi		,(CPU_OFS+32)
	MOVL    $a_rs4300i_addiu	,(CPU_OFS+36)
	MOVL    $a_rs4300i_slti		,(CPU_OFS+40) 
	MOVL    $a_rs4300i_sltiu	,(CPU_OFS+44)
	MOVL    $a_rs4300i_andi		,(CPU_OFS+48)
	MOVL    $a_rs4300i_ori		,(CPU_OFS+52)
	MOVL    $a_rs4300i_xori		,(CPU_OFS+56)
	MOVL    $a_rs4300i_lui		,(CPU_OFS+60)
	MOVL    $a_rs4300i_cop0		,(CPU_OFS+64)
	MOVL    $a_rs4300i_cop1		,(CPU_OFS+68)
	MOVL    $a_rs4300i_cop2		,(CPU_OFS+72)
	MOVL    $a_rs4300i_reserved	,(CPU_OFS+76)
	MOVL    $a_rs4300i_beql		,(CPU_OFS+80)
	MOVL    $a_rs4300i_bnel		,(CPU_OFS+84)
	MOVL    $a_rs4300i_blezl	,(CPU_OFS+88)
	MOVL    $a_rs4300i_bgtzl	,(CPU_OFS+92)
	MOVL    $a_rs4300i_daddi	,(CPU_OFS+96)
	MOVL    $a_rs4300i_daddiu	,(CPU_OFS+100)
	MOVL    $a_rs4300i_ldl		,(CPU_OFS+104)
	MOVL    $a_rs4300i_ldr		,(CPU_OFS+108)
	MOVL    $a_rs4300i_reserved	,(CPU_OFS+112)
	MOVL    $a_rs4300i_reserved	,(CPU_OFS+116)
	MOVL    $a_rs4300i_reserved	,(CPU_OFS+120)
	MOVL    $a_rs4300i_reserved	,(CPU_OFS+124)
	MOVL    $a_rs4300i_lb		,(CPU_OFS+128)
	MOVL    $a_rs4300i_lh		,(CPU_OFS+132)
	MOVL    $a_rs4300i_lwl		,(CPU_OFS+136)
	MOVL    $a_rs4300i_lw		,(CPU_OFS+140)
	MOVL    $a_rs4300i_lbu		,(CPU_OFS+144)
	MOVL    $a_rs4300i_lhu		,(CPU_OFS+148)
	MOVL    $a_rs4300i_lwr		,(CPU_OFS+152)
	MOVL    $a_rs4300i_lwu		,(CPU_OFS+156)
	MOVL    $a_rs4300i_sb		,(CPU_OFS+160)
	MOVL    $a_rs4300i_sh		,(CPU_OFS+164)
	MOVL    $a_rs4300i_swl		,(CPU_OFS+168)
	MOVL    $a_rs4300i_sw		,(CPU_OFS+172)
	MOVL    $a_rs4300i_sdl		,(CPU_OFS+176)
	MOVL    $a_rs4300i_sdr		,(CPU_OFS+180)
	MOVL    $a_rs4300i_swr		,(CPU_OFS+184)
	MOVL    $a_rs4300i_cache	,(CPU_OFS+188)
	MOVL    $a_rs4300i_ll		,(CPU_OFS+192)
	MOVL    $a_rs4300i_lwc1		,(CPU_OFS+196) 
	MOVL    $a_rs4300i_lwc2		,(CPU_OFS+200)
	MOVL    $a_rs4300i_reserved	,(CPU_OFS+204)
	MOVL    $a_rs4300i_lld		,(CPU_OFS+208)
	MOVL    $a_rs4300i_ldc1		,(CPU_OFS+212)	
	MOVL    $a_rs4300i_ldc2		,(CPU_OFS+216)
	MOVL    $a_rs4300i_ld		,(CPU_OFS+220)
	MOVL    $a_rs4300i_sc		,(CPU_OFS+224)
	MOVL    $a_rs4300i_swc1		,(CPU_OFS+228)
	MOVL    $a_rs4300i_swc2		,(CPU_OFS+232)
	MOVL    $a_rs4300i_reserved	,(CPU_OFS+236)
	MOVL    $a_rs4300i_scd		,(CPU_OFS+240)
	MOVL    $a_rs4300i_sdc1		,(CPU_OFS+244)
	MOVL    $a_rs4300i_sdc2		,(CPU_OFS+248)
	MOVL    $a_rs4300i_sd		,(CPU_OFS+252)

        MOVL    $a_rs4300i_special_sll	,(SPEC_OFS+0)
	MOVL    $a_rs4300i_reserved	,(SPEC_OFS+4)
	MOVL    $a_rs4300i_special_srl	,(SPEC_OFS+8)
	MOVL    $a_rs4300i_special_sra	,(SPEC_OFS+12)
	MOVL    $a_rs4300i_special_sllv	,(SPEC_OFS+16)
	MOVL    $a_rs4300i_reserved	,(SPEC_OFS+20)
	MOVL    $a_rs4300i_special_srlv	,(SPEC_OFS+24)
	MOVL    $a_rs4300i_special_srav	,(SPEC_OFS+28)
	MOVL    $a_rs4300i_special_jr	,(SPEC_OFS+32)
	MOVL    $a_rs4300i_special_jalr	,(SPEC_OFS+36)
	MOVL    $a_rs4300i_reserved	,(SPEC_OFS+40)
	MOVL    $a_rs4300i_reserved	,(SPEC_OFS+44)
	MOVL    $a_rs4300i_special_syscall,(SPEC_OFS+48)
	MOVL    $a_rs4300i_special_break,(SPEC_OFS+52)
	MOVL    $a_rs4300i_reserved	,(SPEC_OFS+56)
	MOVL    $a_rs4300i_special_sync	,(SPEC_OFS+60)
	MOVL    $a_rs4300i_special_mfhi	,(SPEC_OFS+64)
	MOVL    $a_rs4300i_special_mthi	,(SPEC_OFS+68)
	MOVL    $a_rs4300i_special_mflo	,(SPEC_OFS+72)
	MOVL    $a_rs4300i_special_mtlo	,(SPEC_OFS+76)
	MOVL    $a_rs4300i_special_dsllv,(SPEC_OFS+80)
	MOVL    $a_rs4300i_reserved	,(SPEC_OFS+84)
	MOVL    $a_rs4300i_special_dsrlv,(SPEC_OFS+88)
	MOVL    $a_rs4300i_special_dsrav,(SPEC_OFS+92)
	MOVL    $a_rs4300i_special_mult	,(SPEC_OFS+96)
	MOVL    $a_rs4300i_special_multu,(SPEC_OFS+100)
	MOVL    $a_rs4300i_special_div	,(SPEC_OFS+104)
	MOVL    $a_rs4300i_special_divu	,(SPEC_OFS+108)
	MOVL    $a_rs4300i_special_dmult,(SPEC_OFS+112)
	MOVL    $a_rs4300i_special_dmultu,(SPEC_OFS+116)
	MOVL    $a_rs4300i_special_ddiv	,(SPEC_OFS+120)
	MOVL    $a_rs4300i_special_ddivu,(SPEC_OFS+124)
	MOVL    $a_rs4300i_special_add	,(SPEC_OFS+128)
	MOVL    $a_rs4300i_special_addu	,(SPEC_OFS+132)
	MOVL    $a_rs4300i_special_sub	,(SPEC_OFS+136)
	MOVL    $a_rs4300i_special_subu	,(SPEC_OFS+140)
	MOVL    $a_rs4300i_special_and	,(SPEC_OFS+144)
	MOVL    $a_rs4300i_special_or	,(SPEC_OFS+148)
	MOVL    $a_rs4300i_special_xor	,(SPEC_OFS+152)
	MOVL    $a_rs4300i_special_nor	,(SPEC_OFS+156)
	MOVL    $a_rs4300i_reserved	,(SPEC_OFS+160)
	MOVL    $a_rs4300i_reserved	,(SPEC_OFS+164)
	MOVL    $a_rs4300i_special_slt	,(SPEC_OFS+168)
	MOVL    $a_rs4300i_special_sltu	,(SPEC_OFS+172)
	MOVL    $a_rs4300i_special_dadd	,(SPEC_OFS+176)
	MOVL    $a_rs4300i_special_daddu,(SPEC_OFS+180)
	MOVL    $a_rs4300i_special_dsub	,(SPEC_OFS+184)
	MOVL    $a_rs4300i_special_dsubu,(SPEC_OFS+188)
	MOVL    $a_rs4300i_special_tge	,(SPEC_OFS+192)
	MOVL    $a_rs4300i_special_tgeu	,(SPEC_OFS+196)
	MOVL    $a_rs4300i_special_tlt	,(SPEC_OFS+200)
	MOVL    $a_rs4300i_special_tltu	,(SPEC_OFS+204)
	MOVL    $a_rs4300i_special_teq	,(SPEC_OFS+208)
	MOVL    $a_rs4300i_reserved	,(SPEC_OFS+212)
	MOVL    $a_rs4300i_special_tne	,(SPEC_OFS+216)
	MOVL    $a_rs4300i_reserved	,(SPEC_OFS+220)
	MOVL    $a_rs4300i_special_dsll	,(SPEC_OFS+224)
	MOVL    $a_rs4300i_reserved	,(SPEC_OFS+228)
	MOVL    $a_rs4300i_special_dsrl	,(SPEC_OFS+232)
	MOVL    $a_rs4300i_special_dsra	,(SPEC_OFS+236)
	MOVL    $a_rs4300i_special_dsll32,(SPEC_OFS+240)
	MOVL    $a_rs4300i_reserved	,(SPEC_OFS+244)
	MOVL    $a_rs4300i_special_dsrl32,(SPEC_OFS+248)
	MOVL    $a_rs4300i_special_dsra32,(SPEC_OFS+252)

        MOVL    $a_rs4300i_regimm_bltz	,(REGIMM_OFS+0)
	MOVL    $a_rs4300i_regimm_bgez	,(REGIMM_OFS+4)
	MOVL    $a_rs4300i_regimm_bltzl	,(REGIMM_OFS+8)
	MOVL    $a_rs4300i_regimm_bgezl	,(REGIMM_OFS+12)
	MOVL    $a_rs4300i_reserved	,(REGIMM_OFS+16)
	MOVL    $a_rs4300i_reserved	,(REGIMM_OFS+20)
	MOVL    $a_rs4300i_reserved	,(REGIMM_OFS+24)
	MOVL    $a_rs4300i_reserved	,(REGIMM_OFS+28)
	MOVL    $a_rs4300i_regimm_tgei	,(REGIMM_OFS+32)
	MOVL    $a_rs4300i_regimm_tgeiu	,(REGIMM_OFS+36)
	MOVL    $a_rs4300i_regimm_tlti	,(REGIMM_OFS+40)
	MOVL    $a_rs4300i_regimm_tltiu	,(REGIMM_OFS+44)
	MOVL    $a_rs4300i_regimm_teqi	,(REGIMM_OFS+48)
	MOVL    $a_rs4300i_reserved	,(REGIMM_OFS+52)
	MOVL    $a_rs4300i_regimm_tnei	,(REGIMM_OFS+56)
	MOVL    $a_rs4300i_reserved	,(REGIMM_OFS+60)
	MOVL    $a_rs4300i_regimm_bltzal,(REGIMM_OFS+64)
	MOVL    $a_rs4300i_regimm_bgezal,(REGIMM_OFS+68)
	MOVL    $a_rs4300i_regimm_bltzall,(REGIMM_OFS+72)
	MOVL    $a_rs4300i_regimm_bgezall,(REGIMM_OFS+76)
	MOVL    $a_rs4300i_reserved	,(REGIMM_OFS+80)
	MOVL    $a_rs4300i_reserved	,(REGIMM_OFS+84)
	MOVL    $a_rs4300i_reserved	,(REGIMM_OFS+88)
	MOVL    $a_rs4300i_reserved	,(REGIMM_OFS+92)
	MOVL    $a_rs4300i_reserved	,(REGIMM_OFS+96)
	MOVL    $a_rs4300i_reserved	,(REGIMM_OFS+100)
	MOVL    $a_rs4300i_reserved	,(REGIMM_OFS+104)
	MOVL    $a_rs4300i_reserved	,(REGIMM_OFS+108)
	MOVL    $a_rs4300i_reserved	,(REGIMM_OFS+112)
	MOVL    $a_rs4300i_reserved	,(REGIMM_OFS+116)
	MOVL    $a_rs4300i_reserved	,(REGIMM_OFS+120)
	MOVL    $a_rs4300i_reserved	,(REGIMM_OFS+124)

        MOVL    $a_rs4300i_reserved	,(COP0_OFS+0)
	MOVL    $rs4300i_cop0_tlbr	,(COP0_OFS+4)
	MOVL    $rs4300i_cop0_tlbwi	,(COP0_OFS+8)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+12)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+16)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+20)
	MOVL    $rs4300i_cop0_tlbwr	,(COP0_OFS+24)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+28)
	MOVL    $rs4300i_cop0_tlbp	,(COP0_OFS+32)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+36)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+40)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+44)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+48)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+52)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+56)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+60)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+64)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+68)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+72)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+76)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+80)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+84)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+88)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+92)
	MOVL    $rs4300i_cop0_eret	,(COP0_OFS+96)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+100)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+104)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+108)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+112)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+116)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+120)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+124)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+128)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+132)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+136)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+140)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+144)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+148)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+152)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+156)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+160)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+164)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+168)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+172)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+176)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+180)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+184)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+188)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+192)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+196)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+200)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+204)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+208)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+212)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+216)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+220)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+224)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+228)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+232)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+236)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+240)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+244)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+248)
	MOVL    $a_rs4300i_reserved	,(COP0_OFS+252)

        MOVL    $rs4300i_cop0_rs_mf	,(COP0_RS_OFS+0)
	MOVL    $rs4300i_cop0_rs_dmf	,(COP0_RS_OFS+4)
	MOVL    $rs4300i_cop0_rs_cf	,(COP0_RS_OFS+8)
	MOVL    $a_rs4300i_reserved	,(COP0_RS_OFS+12)
	MOVL    $rs4300i_cop0_rs_mt	,(COP0_RS_OFS+16)
	MOVL    $rs4300i_cop0_rs_dmt	,(COP0_RS_OFS+20)
	MOVL    $rs4300i_cop0_rs_ct	,(COP0_RS_OFS+24)
	MOVL    $a_rs4300i_reserved	,(COP0_RS_OFS+28)
	MOVL    $rs4300i_cop0_rs_bc	,(COP0_RS_OFS+32)
	MOVL    $a_rs4300i_reserved	,(COP0_RS_OFS+36)
	MOVL    $a_rs4300i_reserved	,(COP0_RS_OFS+40)
	MOVL    $a_rs4300i_reserved	,(COP0_RS_OFS+44)
	MOVL    $a_rs4300i_reserved	,(COP0_RS_OFS+48)
	MOVL    $a_rs4300i_reserved	,(COP0_RS_OFS+52)
	MOVL    $a_rs4300i_reserved	,(COP0_RS_OFS+56)
	MOVL    $a_rs4300i_reserved	,(COP0_RS_OFS+60)
	MOVL    $a_rs4300i_cop0_rs_co	,(COP0_RS_OFS+64)
	MOVL    $a_rs4300i_cop0_rs_co	,(COP0_RS_OFS+68)
	MOVL    $a_rs4300i_cop0_rs_co	,(COP0_RS_OFS+72)
	MOVL    $a_rs4300i_cop0_rs_co	,(COP0_RS_OFS+76)
	MOVL    $a_rs4300i_cop0_rs_co	,(COP0_RS_OFS+80)
	MOVL    $a_rs4300i_cop0_rs_co	,(COP0_RS_OFS+84)
	MOVL    $a_rs4300i_cop0_rs_co	,(COP0_RS_OFS+88)
	MOVL    $a_rs4300i_cop0_rs_co	,(COP0_RS_OFS+92)
	MOVL    $a_rs4300i_cop0_rs_co	,(COP0_RS_OFS+96)
	MOVL    $a_rs4300i_cop0_rs_co	,(COP0_RS_OFS+100)
	MOVL    $a_rs4300i_cop0_rs_co	,(COP0_RS_OFS+104)
	MOVL    $a_rs4300i_cop0_rs_co	,(COP0_RS_OFS+108)
	MOVL    $a_rs4300i_cop0_rs_co	,(COP0_RS_OFS+112)
	MOVL    $a_rs4300i_cop0_rs_co	,(COP0_RS_OFS+116)
	MOVL    $a_rs4300i_cop0_rs_co	,(COP0_RS_OFS+120)
	MOVL    $a_rs4300i_cop0_rs_co	,(COP0_RS_OFS+124)

        MOVL    $a_rs4300i_cop0_rt_bcf	,(COP0_RT_OFS+0)
	MOVL    $a_rs4300i_cop0_rt_bct	,(COP0_RT_OFS+4)
	MOVL    $a_rs4300i_cop0_rt_bcfl	,(COP0_RT_OFS+8)
	MOVL    $a_rs4300i_cop0_rt_bctl	,(COP0_RT_OFS+12)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+16)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+20)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+24)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+28)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+32)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+36)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+40)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+44)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+48)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+52)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+56)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+60)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+64)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+68)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+72)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+76)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+80)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+84)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+88)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+92)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+96)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+100)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+104)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+108)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+112)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+116)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+120)
	MOVL    $a_rs4300i_reserved	,(COP0_RT_OFS+124)


   	MOVL    $a_rs4300i_cop1_add	,(COP1_OFS+0)
	MOVL    $a_rs4300i_cop1_sub	,(COP1_OFS+4)
	MOVL    $a_rs4300i_cop1_mul	,(COP1_OFS+8)
	MOVL    $a_rs4300i_cop1_div	,(COP1_OFS+12)
	MOVL    $a_rs4300i_cop1_sqrt	,(COP1_OFS+16)
	MOVL    $a_rs4300i_cop1_abs	,(COP1_OFS+20)
	MOVL    $a_rs4300i_cop1_mov	,(COP1_OFS+24)
	MOVL    $a_rs4300i_cop1_neg	,(COP1_OFS+28)
	MOVL    $rs4300i_cop1_roundl	,(COP1_OFS+32) # due to some fpu exception problems
	MOVL    $rs4300i_cop1_truncl	,(COP1_OFS+36)
	MOVL    $rs4300i_cop1_ceill	,(COP1_OFS+40)
	MOVL    $rs4300i_cop1_floorl	,(COP1_OFS+44)
	MOVL    $rs4300i_cop1_roundw	,(COP1_OFS+48)
	MOVL    $rs4300i_cop1_truncw	,(COP1_OFS+52)
	MOVL    $rs4300i_cop1_ceilw	,(COP1_OFS+56)
	MOVL    $rs4300i_cop1_floorw	,(COP1_OFS+60)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+64)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+68)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+72)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+76)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+80)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+84)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+88)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+92)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+96)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+100)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+104)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+108)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+112)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+116)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+120)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+124)
	MOVL    $a_rs4300i_cop1_cvts	,(COP1_OFS+128)
	MOVL    $a_rs4300i_cop1_cvtd	,(COP1_OFS+132)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+136)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+140)
	MOVL    $a_rs4300i_cop1_cvtw	,(COP1_OFS+144)
	MOVL    $a_rs4300i_cop1_cvtl	,(COP1_OFS+148)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+152)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+156)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+160)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+164)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+168)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+172)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+176)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+180)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+184)
	MOVL    $a_rs4300i_reserved	,(COP1_OFS+188)
	MOVL    $a_rs4300i_cop1_c	,(COP1_OFS+192)
	MOVL    $a_rs4300i_cop1_c	,(COP1_OFS+196)
	MOVL    $a_rs4300i_cop1_c	,(COP1_OFS+200)
	MOVL    $a_rs4300i_cop1_c	,(COP1_OFS+204)
	MOVL    $a_rs4300i_cop1_c	,(COP1_OFS+208)
	MOVL    $a_rs4300i_cop1_c	,(COP1_OFS+212)
	MOVL    $a_rs4300i_cop1_c	,(COP1_OFS+216)
	MOVL    $a_rs4300i_cop1_c	,(COP1_OFS+220)
	MOVL    $a_rs4300i_cop1_c	,(COP1_OFS+224)
	MOVL    $a_rs4300i_cop1_c	,(COP1_OFS+228)
	MOVL    $a_rs4300i_cop1_c	,(COP1_OFS+232)
	MOVL    $a_rs4300i_cop1_c	,(COP1_OFS+236)
	MOVL    $a_rs4300i_cop1_c	,(COP1_OFS+240)
	MOVL    $a_rs4300i_cop1_c	,(COP1_OFS+244)
	MOVL    $rs4300i_cop1_c	,(COP1_OFS+248)
	MOVL    $a_rs4300i_cop1_c	,(COP1_OFS+252)

        MOVL    $a_rs4300i_cop1_rs_mf	,(COP1_RS_OFS+0)
	MOVL    $a_rs4300i_cop1_rs_dmf	,(COP1_RS_OFS+4)
	MOVL    $a_rs4300i_cop1_rs_cf	,(COP1_RS_OFS+8)
	MOVL    $a_rs4300i_reserved	,(COP1_RS_OFS+12)
	MOVL    $a_rs4300i_cop1_rs_mt	,(COP1_RS_OFS+16)
	MOVL    $a_rs4300i_cop1_rs_dmt	,(COP1_RS_OFS+20)
	MOVL    $a_rs4300i_cop1_rs_ct	,(COP1_RS_OFS+24)
	MOVL    $a_rs4300i_reserved	,(COP1_RS_OFS+28)
	MOVL    $a_rs4300i_cop1_rs_bc	,(COP1_RS_OFS+32)
	MOVL    $a_rs4300i_reserved	,(COP1_RS_OFS+36)
	MOVL    $a_rs4300i_reserved	,(COP1_RS_OFS+40)
	MOVL    $a_rs4300i_reserved	,(COP1_RS_OFS+44)
	MOVL    $a_rs4300i_reserved	,(COP1_RS_OFS+48)
	MOVL    $a_rs4300i_reserved	,(COP1_RS_OFS+52)
	MOVL    $a_rs4300i_reserved	,(COP1_RS_OFS+56)
	MOVL    $a_rs4300i_reserved	,(COP1_RS_OFS+60)
	MOVL    $a_rs4300i_cop1_rs_co	,(COP1_RS_OFS+64)
	MOVL    $a_rs4300i_cop1_rs_co	,(COP1_RS_OFS+68)
	MOVL    $a_rs4300i_cop1_rs_co	,(COP1_RS_OFS+72)
	MOVL    $a_rs4300i_cop1_rs_co	,(COP1_RS_OFS+76)
	MOVL    $a_rs4300i_cop1_rs_co	,(COP1_RS_OFS+80)
	MOVL    $a_rs4300i_cop1_rs_co	,(COP1_RS_OFS+84)
	MOVL    $a_rs4300i_cop1_rs_co	,(COP1_RS_OFS+88)
	MOVL    $a_rs4300i_cop1_rs_co	,(COP1_RS_OFS+92)
	MOVL    $a_rs4300i_cop1_rs_co	,(COP1_RS_OFS+96)
	MOVL    $a_rs4300i_cop1_rs_co	,(COP1_RS_OFS+100)
	MOVL    $a_rs4300i_cop1_rs_co	,(COP1_RS_OFS+104)
	MOVL    $a_rs4300i_cop1_rs_co	,(COP1_RS_OFS+108)
	MOVL    $a_rs4300i_cop1_rs_co	,(COP1_RS_OFS+112)
	MOVL    $a_rs4300i_cop1_rs_co	,(COP1_RS_OFS+116)
	MOVL    $a_rs4300i_cop1_rs_co	,(COP1_RS_OFS+120)
	MOVL    $a_rs4300i_cop1_rs_co	,(COP1_RS_OFS+124)

        MOVL    $a_rs4300i_cop1_rt_bcf	,(COP1_RT_OFS+0)
	MOVL    $a_rs4300i_cop1_rt_bct	,(COP1_RT_OFS+4)
	MOVL    $a_rs4300i_cop1_rt_bcfl	,(COP1_RT_OFS+8)
	MOVL    $a_rs4300i_cop1_rt_bctl	,(COP1_RT_OFS+12)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+16)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+20)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+24)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+28)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+32)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+36)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+40)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+44)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+48)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+52)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+56)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+60)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+64)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+68)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+72)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+76)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+80)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+84)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+88)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+92)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+96)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+100)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+104)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+108)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+112)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+116)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+120)
	MOVL    $a_rs4300i_reserved	,(COP1_RT_OFS+124)

	MOVL	$a_rs4300i_cop1_cf	,(COP1_CTBL+0)
	MOVL	$a_rs4300i_cop1_cres	,(COP1_CTBL+4)
	MOVL	$a_rs4300i_cop1_ceq	,(COP1_CTBL+8)
	MOVL	$a_rs4300i_cop1_cueq	,(COP1_CTBL+12)
	MOVL	$a_rs4300i_cop1_cres	,(COP1_CTBL+16)
	MOVL	$a_rs4300i_cop1_cres	,(COP1_CTBL+20)
	MOVL	$a_rs4300i_cop1_cres	,(COP1_CTBL+24)
	MOVL	$a_rs4300i_cop1_cres	,(COP1_CTBL+28)
	MOVL	$a_rs4300i_cop1_cres	,(COP1_CTBL+32)
	MOVL	$a_rs4300i_cop1_cres	,(COP1_CTBL+36)
	MOVL	$a_rs4300i_cop1_cres	,(COP1_CTBL+40)
	MOVL	$a_rs4300i_cop1_cres	,(COP1_CTBL+44)
	MOVL	$a_rs4300i_cop1_clt	,(COP1_CTBL+48)
	MOVL	$a_rs4300i_cop1_cnge	,(COP1_CTBL+52)
	MOVL	$a_rs4300i_cop1_cle	,(COP1_CTBL+56)
	MOVL	$a_rs4300i_cop1_cngt	,(COP1_CTBL+60)


        MOVL    $a_rs4300i_reserved	,(COP2_OFS+0)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+4)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+8)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+12)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+16)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+20)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+24)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+28)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+32)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+36)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+40)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+44)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+48)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+52)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+56)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+60)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+64)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+68)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+72)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+76)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+80)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+84)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+88)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+92)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+96)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+100)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+104)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+108)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+112)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+116)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+120)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+124)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+128)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+132)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+136)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+140)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+144)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+148)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+152)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+156)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+160)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+164)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+168)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+172)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+176)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+180)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+184)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+188)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+192)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+196)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+200)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+204)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+208)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+212)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+216)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+220)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+224)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+228)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+232)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+236)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+240)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+244)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+248)
	MOVL    $a_rs4300i_reserved	,(COP2_OFS+252)

        MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+0)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+4)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+8)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+12)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+16)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+20)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+24)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+28)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+32)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+36)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+40)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+44)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+48)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+52)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+56)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+60)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+64)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+68)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+72)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+76)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+80)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+84)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+88)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+92)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+96)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+100)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+104)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+108)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+112)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+116)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+120)
	MOVL    $a_rs4300i_reserved	,(COP2_RS_OFS+124)

        MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+0)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+4)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+8)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+12)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+16)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+20)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+24)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+28)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+32)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+36)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+40)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+44)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+48)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+52)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+56)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+60)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+64)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+68)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+72)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+76)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+80)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+84)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+88)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+92)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+96)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+100)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+104)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+108)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+112)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+116)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+120)
	MOVL    $a_rs4300i_reserved	,(COP2_RT_OFS+124)
	RET

.align 16
rs4300i_doCode:
	CMPL	$0,DOSOMETHING
	JE temporary3
	CALL	procdosomething
temporary3:
	MOVL	(PC),%EAX 		#get next command \n 
	cmpl	$0xa4000040,%EAX
	JAE	temporary6
	ANDL	$0x003fffff,%EAX
	ADDL	rd_ram,%EAX
	JMP	temporary7
temporary6:
	ANDL	$0xfff,%EAX
	ADDL	sp_dmem,%EAX
temporary7:
	MOVL	(%EAX),%EAX
	MOVL	%EAX,CODE
	MOVL	%EAX,%EBX		#extract opcode   
	SHRL	$24,%EBX				  
	ANDL	$252,%EBX	
#	INCL	cpustat(%EBX)
	CALL	CPU_OFS(%EBX)				  
	MOVL	DELAY,%EBX
	MOVL	$0,REG_OFS
	DECL	%EBX
	MOVL	$0,REG_OFS+4
	JS	temporary
	DECL	%EBX
	JS	temporary2
	MOVL	PC_DELAY,%ECX
	MOVL	%ECX,PC
	MOVL	$0,DELAY
	MOVL	CPR0_OFS+COUNT,%EAX
	JMP	temporary1
temporary2:
	MOVL	$2,DELAY
temporary:
	ADDL	$4,PC
	MOVL	CPR0_OFS+COUNT,%EAX
temporary1:
	CMPL	CPR0_OFS+COMPARE,%EAX
	JNE	temporary4
	PUSHL	%EAX
	call	rs4300i_CompareInterrupt
	POPL	%EAX
temporary4:
	#CMPL	INTRVITIME,%EAX                 # begin hope this works (niki)
	CMPL    next_vi_interrupt,%EAX
        #                                       # end   hope this works (niki)
	JNE	temporary5
	PUSHL	%EAX
	call	rs4300i_MI_Intr_VI
	POPL	%EAX
temporary5:
	INCL	%EAX
	MOVL	%EAX,CPR0_OFS+COUNT
#	CMPL	$00,HALT
#	JE	rs4300i_doCode
	RET

MEM_READ_BYTE:
	PUSHL	%EAX
	PUSHL	%EBX
	PUSHL	%ECX
	CALL	doReadMemByte
	MOVB	%AL,%DL
	POPL	%ECX
	POPL	%EBX
	POPL	%EAX
	RET

MEM_READ_HWORD:
	PUSHL	%EAX
	PUSHL	%EBX
	PUSHL	%ECX
	CALL	doReadMemHalfWord
	MOVW	%AX,%DX
	POPL	%ECX
	POPL	%EBX
	POPL	%EAX
	RET

MEM_READ_WORD:
	PUSHL	%EAX
	PUSHL	%EBX
	PUSHL	%ECX
	CALL	doReadMemWord
	MOVL	%EAX,%EDX
	POPL	%ECX
	POPL	%EBX
	POPL	%EAX
	RET	

MEM_READ_DWORD:
	PUSHL	%EAX
	PUSHL	%ECX
	CALL	doReadMemDoubleWord
	MOVL	%EDX,%EBX
	MOVL	%EAX,%EDX
	POPL	%ECX
	POPL	%EAX
	RET	

MEM_WRITE_BYTE:
	PUSHL	%EAX
	PUSHL	%EBX
	PUSHL	%ECX
	PUSHL	%EDX
	CALL	doWriteMemByte
	POPL	%EDX
	POPL	%ECX
	POPL	%EBX
	POPL	%EAX
	RET

MEM_WRITE_HWORD:
	PUSHL	%EAX
	PUSHL	%EBX
	PUSHL	%ECX
	PUSHL	%EDX
	CALL	doWriteMemHalfWord
	POPL	%EDX
	POPL	%ECX
	POPL	%EBX
	POPL	%EAX
	RET

MEM_WRITE_WORD:
	PUSHL	%EAX
	PUSHL	%EBX
	PUSHL	%ECX
	PUSHL	%EDX
	CALL	doWriteMemWord
	POPL	%EDX
	POPL	%ECX
	POPL	%EBX
	POPL	%EAX
	RET

MEM_WRITE_DWORD:
	PUSHL	%EAX
	PUSHL	%ECX
	PUSHL	%EBX
	PUSHL	%EDX
	CALL	doWriteMemDoubleWord
	POPL	%EDX
	POPL	%EBX
	POPL	%ECX
	POPL	%EAX
	RET


CPU_UNDEF:
a_rs4300i_reserved:
	MOVL	$1,HALT
	GOTONEXTCMD


a_rs4300i_special:
	MOVL	%EAX,%EBX		#extract opcode   
	SHLL	$2,%EBX				  
	ANDL	$252,%EBX			          
	JMP	SPEC_OFS(%EBX)				  

a_rs4300i_regimm:
	MOVL	%EAX,%EBX		#extract opcode   
	SHRL	$14,%EBX				  
	ANDL	$124,%EBX			          
	JMP	REGIMM_OFS(%EBX)				  


a_rs4300i_j:	GETTARGET
	SHLL	$2,%EBX
	MOVL	PC,%ECX
	#SKIPTIME                       # fix it (niki)
	ANDL	$0xf0000000,%ECX
	ORL	%EBX,%ECX
	MOVL	%ECX,PC_DELAY
	MOVL	$1,DELAY
	GOTONEXTCMD		


a_rs4300i_jal:GETTARGET
	SHLL	$2,%EBX
	ANDL	$0xfffffffc,%EBX
	MOVL	PC,%ECX
	ANDL	$0xf0000000,%ECX
	ORL	%EBX,%ECX
	MOVL	%ECX,PC_DELAY
	MOVL	PC,%EBX
	ADDL	$8,%EBX
	MOVL	%EBX,248+REG_OFS
	MOVL	$1,DELAY
	GOTONEXTCMD		


a_rs4300i_beq:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	GETTARGREG
	CMPL	REG_OFS(%EBX),%ECX
	JNE	a_rs4300i_BEQ1
	MOVL	PC,%ECX
	MOVL	%ECX,PC_DELAY
	MOVL	$1,DELAY
	ADDL	$4,PC_DELAY
	GETINDEX
	#SKIPTIMEC                      # fix it (niki)
	SHLL	$2,%EBX
	ADDL	%EBX,PC_DELAY
	MOVL	$1,DELAY
a_rs4300i_BEQ1:GOTONEXTCMD


a_rs4300i_bne:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	GETTARGREG
	CMPL	REG_OFS(%EBX),%ECX
	JNE	a_rs4300i_BNE1
	GOTONEXTCMD
a_rs4300i_BNE1:
	MOVL	PC,%ECX
	MOVL	%ECX,PC_DELAY
	ADDL	$4,PC_DELAY
	GETINDEX
	#SKIPTIMEC                      # fix it (niki)
	SHLL	$2,%EBX
	ADDL	%EBX,PC_DELAY
	MOVL	$1,DELAY
        GOTONEXTCMD


a_rs4300i_blez:GETSRCREG
	CMPL	$0,REG_OFS(%EBX)
	JG	a_rs4300i_BLEZ1
	MOVL	PC,%ECX
	MOVL	%ECX,PC_DELAY
	ADDL	$4,PC_DELAY
	GETINDEX
	#SKIPTIMEC                      # fix it (niki)
	SHLL	$2,%EBX
	ADDL	%EBX,PC_DELAY
	MOVL	$1,DELAY
a_rs4300i_BLEZ1:
	GOTONEXTCMD


a_rs4300i_bgtz:GETSRCREG
	CMPL	$0,REG_OFS(%EBX)
	JLE	a_rs4300i_BGTZ1
	MOVL	PC,%ECX
	MOVL	%ECX,PC_DELAY
	ADDL	$4,PC_DELAY
	GETINDEX
	#SKIPTIMEC                      # fix it (niki)
	SHLL	$2,%EBX
	ADDL	%EBX,PC_DELAY
	MOVL	$1,DELAY
a_rs4300i_BGTZ1:
	GOTONEXTCMD
	

a_rs4300i_addi:
	GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	MOVSWL	%AX,%EBX
	ADDL	%EBX,%ECX
	GETTARGREG
	MOVL	%ECX,REG_OFS(%EBX)
	SARL	$31,%ECX
	MOVL	%ECX,REG_OFS+4(%EBX)
	GOTONEXTCMD


a_rs4300i_addiu:
	GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	MOVSWL	%AX,%EBX
	ADDL	%EBX,%ECX
	GETTARGREG
	MOVL	%ECX,REG_OFS(%EBX)
	SARL	$31,%ECX
	MOVL	%ECX,REG_OFS+4(%EBX)
	GOTONEXTCMD



a_rs4300i_slti:MOVSWL	%AX,%ECX
	MOVL	%ECX,%EDX
	SARL	$31,%EDX
	GETSRCREG

	CMPL	%EDX,REG_OFS+4(%EBX)
	JL	a_rs4300i_slti1
	CMPL	%EDX,REG_OFS+4(%EBX)
	JNE	a_rs4300i_slti2
	CMPL	%ECX,REG_OFS(%EBX)
	JB	a_rs4300i_slti1
a_rs4300i_slti2:
	GETTARGREG
	MOVL	$0,REG_OFS+4(%EBX)
	MOVL	$0,REG_OFS(%EBX)
	GOTONEXTCMD
a_rs4300i_slti1:
	GETTARGREG
	MOVL	$0,REG_OFS+4(%EBX)
	MOVL	$1,REG_OFS(%EBX)
	GOTONEXTCMD


a_rs4300i_sltiu:MOVSWL	%AX,%ECX
	MOVL	%ECX,%EDX
	SARL	$31,%EDX
	GETSRCREG
	CMPL	%EDX,REG_OFS+4(%EBX)
	JL	a_rs4300i_sltiu1
	CMPL	%EDX,REG_OFS+4(%EBX)
	JNE	a_rs4300i_sltiu2
	CMPL	%ECX,REG_OFS(%EBX)
	JB	a_rs4300i_sltiu1
a_rs4300i_sltiu2:
	GETTARGREG
	MOVL	$0,REG_OFS+4(%EBX)
	MOVL	$0,REG_OFS(%EBX)
	GOTONEXTCMD
a_rs4300i_sltiu1:
	GETTARGREG
	MOVL	$0,REG_OFS+4(%EBX)
	MOVL	$1,REG_OFS(%EBX)
	GOTONEXTCMD


a_rs4300i_andi:GETSRCREG
	MOVW	REG_OFS(%EBX),%CX
	ANDW	%AX,%CX
	GETTARGREG
	MOVZWL	%CX,%ECX
	MOVL	%ECX,REG_OFS(%EBX)
	MOVL	$0,REG_OFS+4(%EBX)
	GOTONEXTCMD


a_rs4300i_ori:GETSRCREG
	MOVL	REG_OFS(%EBX),%EDX
	MOVL	REG_OFS+4(%EBX),%ECX
	ORW	%AX,%DX
	GETTARGREG
	MOVL	%EDX,REG_OFS(%EBX)
	MOVL	%ECX,REG_OFS+4(%EBX)
	GOTONEXTCMD


a_rs4300i_xori:GETSRCREG
	MOVL	REG_OFS(%EBX),%EDX
	MOVL	REG_OFS+4(%EBX),%ECX
	XORW	%AX,%DX
	GETTARGREG
	MOVL	%EDX,REG_OFS(%EBX)
	MOVL	%ECX,REG_OFS+4(%EBX)
	GOTONEXTCMD


a_rs4300i_lui:GETINDEX
	MOVZWL	%BX,%ECX
	SHLL	$16,%ECX
	GETTARGREG
	MOVL	%ECX,REG_OFS(%EBX)
	SARL	$31,%ECX
	MOVL	%ECX,REG_OFS+4(%EBX)
	GOTONEXTCMD


a_rs4300i_cop0:
	MOVL	%EAX,%EBX		#extract opcode   
	SHRL	$19,%EBX				  
	ANDL	$124,%EBX			          
	JMP	COP0_RS_OFS(%EBX)				  


a_rs4300i_cop1:
	MOVL	%EAX,%EBX		#extract opcode   
	SHRL	$19,%EBX				  
	ANDL	$124,%EBX			          
	JMP	COP1_RS_OFS(%EBX)				  

a_rs4300i_cop2:
	MOVL	%EAX,%EBX		#extract opcode   
	SHRL	$19,%EBX				  
	ANDL	$124,%EBX			          
	JMP	COP2_RS_OFS(%EBX)				  


a_rs4300i_beql:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	GETTARGREG
	CMPL	REG_OFS(%EBX),%ECX
	JNE	a_rs4300i_BEQL1
	MOVL	PC,%ECX
	MOVL	%ECX,PC_DELAY
	MOVL	$1,DELAY
	ADDL	$4,PC_DELAY
	GETINDEX
	SHLL	$2,%EBX
	ADDL	%EBX,PC_DELAY
	MOVL	$1,DELAY
	GOTONEXTCMD
a_rs4300i_BEQL1:ADDL	$4,PC
	GOTONEXTCMD


a_rs4300i_bnel:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	GETTARGREG
	CMPL	REG_OFS(%EBX),%ECX
	JNE	a_rs4300i_BNEL1
	ADDL	$4,PC
	GOTONEXTCMD
a_rs4300i_BNEL1:
	MOVL	PC,%ECX
	MOVL	%ECX,PC_DELAY
	ADDL	$4,PC_DELAY
	GETINDEX
	SHLL	$2,%EBX
	ADDL	%EBX,PC_DELAY
	MOVL	$1,DELAY
        GOTONEXTCMD


a_rs4300i_blezl:GETSRCREG
	CMPL	$0,REG_OFS(%EBX)
	JG	a_rs4300i_BLEZL1
	MOVL	PC,%ECX
	MOVL	%ECX,PC_DELAY
	ADDL	$4,PC_DELAY
	GETINDEX
	SHLL	$2,%EBX
	ADDL	%EBX,PC_DELAY
	MOVL	$1,DELAY
	GOTONEXTCMD
a_rs4300i_BLEZL1:
	ADDL	$4,PC
	GOTONEXTCMD


a_rs4300i_bgtzl:GETSRCREG
	CMPL	$0,REG_OFS(%EBX)
	JNG	a_rs4300i_BGTZL1
	MOVL	PC,%ECX
	MOVL	%ECX,PC_DELAY
	ADDL	$4,PC_DELAY
	GETINDEX
	SHLL	$2,%EBX
	ADDL	%EBX,PC_DELAY
	MOVL	$1,DELAY
	GOTONEXTCMD
a_rs4300i_BGTZL1:
	ADDL	$4,PC
	GOTONEXTCMD


a_rs4300i_daddi:
	GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	MOVL	REG_OFS+4(%EBX),%EDX
	MOVSWL	%AX,%EBX
	MOVL	%EBX,%EDI
	SARL	$31,%EDI
	ADDL	%EBX,%ECX
	ADCL	%EDI,%EDX
	GETTARGREG
	MOVL	%ECX,REG_OFS(%EBX)
	MOVL	%EDX,REG_OFS+4(%EBX)
	GOTONEXTCMD


a_rs4300i_daddiu:
	GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	MOVL	REG_OFS+4(%EBX),%EDX
	MOVSWL	%AX,%EBX
	MOVL	%EBX,%EDI
	SARL	$31,%EDI
	ADDL	%EBX,%ECX
	ADCL	%EDI,%EDX
	GETTARGREG
	MOVL	%ECX,REG_OFS(%EBX)
	MOVL	%EDX,REG_OFS+4(%EBX)
	GOTONEXTCMD



a_rs4300i_ldl:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	GETINDEX
	ADDL	%EBX,%ECX
	MOVL	%ECX,%EDI
	ANDL	$0xFFFFFFF8,%ECX
        CALL	MEM_READ_DWORD 	#ESI:EDX=[%ECX], read that adress
	MOVL	%EBX,%ESI
	GETTARGREG
	MOVL	REG_OFS(%EBX),%ECX
	MOVL	REG_OFS+4(%EBX),%EBP
	XCHG	%ECX,%EDI	#EBP:EDI=register
	ANDL 	$3,%ECX
	SHLL	$2,%ECX
	SHLDL	%CL,%EDX,%ESI
	SHLDL	%CL,%EDX,%ESI
	SUBB	$16,%CL
	NEGB	%CL
	SHLDL	%CL,%EDI,%EBP
	SHLDL	%CL,%EDI,%EBP
	SHRDL	%CL,%EDI,%EBP
	SHRDL	%CL,%EDI,%EBP
	ORL	%EDI,%EDX
	ORL	%EBP,%ESI
	MOVL	%EDX,REG_OFS(%EBX)
	MOVL	%ESI,REG_OFS+4(%EBX)
	GOTONEXTCMD


a_rs4300i_ldr:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	GETINDEX
	ADDL	%EBX,%ECX
	MOVL	%ECX,%EDI
	ANDL	$0xFFFFFFF8,%ECX
        CALL	MEM_READ_DWORD 	#EDX=[%ECX], read that adress
	MOVL	%EBX,%ESI
	GETTARGREG
	MOVL	REG_OFS(%EBX),%ECX
	MOVL	REG_OFS+4(%EBX),%EBP
	XCHGL	%ECX,%EDI
	INCB	%CL
	ANDB	$7,%CL
	SHLB	$2,%CL
	SHRDL	%CL,%EDI,%EBP
	SHRDL	%CL,%EDI,%EBP
	SHLDL	%CL,%EDI,%EBP
	SHLDL	%CL,%EDI,%EBP
	SUBB	$16,%CL
	NEGB	%CL
	SHRDL	%CL,%EDX,%ESI
	SHRDL	%CL,%EDX,%ESI
	ORL	%EDI,%EDX
	ORL	%EBP,%ESI
	MOVL	%EDX,REG_OFS(%EBX)
	MOVL	%ESI,REG_OFS+4(%EBX)
	GOTONEXTCMD



a_rs4300i_sdl:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	GETINDEX
	ADDL	%EBX,%ECX
	PUSHL	%ECX
	ANDL	$0xfffffff8,%ECX
	CALL	MEM_READ_DWORD	# EBX:DSX=WORD
	POPL	%ECX
	PUSHL	%ECX
	ANDB	$7,%CL
	SHLB	$2,%CL
	SUBB	$32,%CL
	NEGB	%CL
	SHRDL	%CL,%EDX,%EBX 
	SHRDL	%CL,%EDX,%EBX 
	SHLDL	%CL,%EDX,%EBX
	SHLDL	%CL,%EDX,%EBX
	PUSHL	%EBX
	PUSHL	%EDX
	GETTARGET
	MOVL	REG_OFS(%EBX),%EDX
	MOVL	REG_OFS+4(%EBX),%EBX
	SUBB	$32,%CL
	NEG	%CL
	SHRDL	%CL,%EDX,%EBX
	SHRDL	%CL,%EDX,%EBX
	POPL	%ECX
	ORL	%ECX,%EBX
	POPL	%ECX
	ORL	%ECX,%EBX
	POPL	%ECX
	ANDL	$0xfffffff8,%ECX
	CALL	MEM_WRITE_DWORD
	GOTONEXTCMD


a_rs4300i_sdr:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	GETINDEX
	ADDL	%EBX,%ECX
	PUSHL	%ECX
	ANDL	$0xfffffff8,%ECX
	CALL	MEM_READ_DWORD	# EBX:DSX=WORD
	POPL	%ECX
	PUSHL	%ECX
	ANDB	$7,%CL
	INCB	%CL
	SHLB	$2,%CL
	SHLDL	%CL,%EDX,%EBX 
	SHLDL	%CL,%EDX,%EBX 
	SHRDL	%CL,%EDX,%EBX
	SHRDL	%CL,%EDX,%EBX
	PUSHL	%EBX
	PUSHL	%EDX
	GETTARGET
	MOVL	REG_OFS(%EBX),%EDX
	MOVL	REG_OFS+4(%EBX),%EBX
	SUBB	$32,%CL
	NEG	%CL
	SHLDL	%CL,%EDX,%EBX
	SHLDL	%CL,%EDX,%EBX
	POPL	%ECX
	ORL	%ECX,%EBX
	POPL	%ECX
	ORL	%ECX,%EBX
	POPL	%ECX
	ANDL	$0xfffffff8,%ECX
	CALL	MEM_WRITE_DWORD
	GOTONEXTCMD


a_rs4300i_lb:	GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX	#get SRCREG register content
	GETINDEX
	ADDL	%EBX,%ECX		#add offset to SRCREG  register content
        CALL	MEM_READ_BYTE 	#dl=[%ECX], read that adress
	GETTARGREG
	MOVSBL	%DL,%EDX		#extend content of memory
	MOVL	%EDX,REG_OFS(%EBX)
	SARL	$31,%EDX
	MOVL	%EDX,REG_OFS+4(%EBX)
	GOTONEXTCMD


a_rs4300i_lh:	GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX	#get SRCREG register content
	GETINDEX
	ADDL	%EBX,%ECX		#add offset to SRCREG  register content
        CALL	MEM_READ_HWORD 	#dl=[%ECX], read that adress
	GETTARGREG
	MOVSWL	%DX,%EDX		#extend content of memory
	MOVL	%EDX,REG_OFS(%EBX)
	SARL	$31,%EDX
	MOVL	%EDX,REG_OFS+4(%EBX)
	GOTONEXTCMD


a_rs4300i_lwl:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	GETINDEX
	ADDL	%EBX,%ECX
	MOVL	%ECX,%EDI
	ANDL	$0xFFFFFFFC,%ECX
        CALL	MEM_READ_WORD 	#dl=[%ECX], read that adress
	GETTARGREG
	MOVL	REG_OFS(%EBX),%ECX
	XCHG	%ECX,%EDI
	ANDL 	$3,%ECX
	SHLL	$2,%ECX
	SHLL	%CL,%EDX
	SHLL	%CL,%EDX
	SUBB	$16,%CL
	NEGB	%CL
	SHLL	%CL,%EDI
	SHLL	%CL,%EDI
	SHRL	%CL,%EDI
	SHRL	%CL,%EDI
	ORL	%EDI,%EDX
	MOVL	%EDX,REG_OFS(%EBX)
	GOTONEXTCMD


a_rs4300i_lw:	GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX	#get SRCREG register content
	GETINDEX
	ADDL	%EBX,%ECX		#add offset to SRCREG  register content
        CALL	MEM_READ_WORD 	#dl=[%ECX], read that adress
	GETTARGREG
	MOVL	%EDX,REG_OFS(%EBX)
	SARL	$31,%EDX
	MOVL	%EDX,REG_OFS+4(%EBX)
	GOTONEXTCMD


a_rs4300i_lbu:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX	#get SRCREG register content
	GETINDEX
	ADDL	%EBX,%ECX		#add offset to SRCREG  register content
        CALL	MEM_READ_BYTE 	#dl=[%ECX], read that adress
	GETTARGREG
	MOVZBL	%DL,%EDX		#extend content of memory
	MOVL	%EDX,REG_OFS(%EBX)
	MOVL	$0,REG_OFS+4(%EBX)
	GOTONEXTCMD


a_rs4300i_lhu:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX	#get SRCREG register content
	GETINDEX
	ADDL	%EBX,%ECX		#add offset to SRCREG  register content
        CALL	MEM_READ_HWORD 	#dl=[%ECX], read that adress
	GETTARGREG
	MOVZWL	%DX,%EDX		#extend content of memory
	MOVL	%EDX,REG_OFS(%EBX)
	MOVL	$0,REG_OFS+4(%EBX)
	GOTONEXTCMD



a_rs4300i_lwr:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	GETINDEX
	ADDL	%EBX,%ECX
	MOVL	%ECX,%EDI
	ANDL	$0xFFFFFFFC,%ECX
        CALL	MEM_READ_WORD 	#EDX=[%ECX], read that adress
	GETTARGREG
	MOVL	REG_OFS(%EBX),%ECX
	XCHGL	%ECX,%EDI
	ANDB	$3,%CL
	INCB	%CL
	SHLB	$2,%CL
	SHRL	%CL,%EDI
	SHRL	%CL,%EDI
	SHLL	%CL,%EDI
	SHLL	%CL,%EDI
	SUBB	$16,%CL
	NEGB	%CL
	SHRL	%CL,%EDX
	SHRL	%CL,%EDX
	ORL	%EDI,%EDX
	MOVL	%EDX,REG_OFS(%EBX)
	SARL	$31,%EDX
	MOVL	%EDX,REG_OFS+4(%EBX)
	GOTONEXTCMD

a_rs4300i_lwu:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX	#get SRCREG register content
	GETINDEX
	ADDL	%EBX,%ECX		#add offset to SRCREG  register content
        CALL	MEM_READ_WORD 	#dl=[%ECX], read that adress
	GETTARGREG
	MOVL	%EDX,REG_OFS(%EBX)
	MOVL	$0,REG_OFS+4(%EBX)
	GOTONEXTCMD


a_rs4300i_sb:	GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX	#get SRCREG register content
	GETINDEX
	ADDL	%EBX,%ECX		#add offset to SRCREG  register content
	GETTARGREG
	MOVB	REG_OFS(%EBX),%DL
        CALL	MEM_WRITE_BYTE 		#[%ECX]=dl, write that adress
	GOTONEXTCMD

a_rs4300i_sh:	GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX	#get SRCREG register content
	GETINDEX
	ADDL	%EBX,%ECX		#add offset to SRCREG  register content
	GETTARGREG
	MOVW	REG_OFS(%EBX),%DX
        CALL	MEM_WRITE_HWORD 		#[%ECX]=dl, write that adress
	GOTONEXTCMD


a_rs4300i_swl:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	GETINDEX
	ADDL	%EBX,%ECX
	MOVL	%ECX,%EDI
	PUSHL	%ECX
	ANDL	$0xfffffffc,%ECX
        CALL	MEM_READ_WORD 	#EDX=[%ECX], read that adress
	GETTARGREG
	MOVL	REG_OFS(%EBX),%ECX
	XCHG	%ECX,%EDI # edi= reg edx=mem
	ANDL 	$3,%ECX
	SHLL	$2,%ECX
	SHLL	%CL,%EDI
	SHLL	%CL,%EDI
	SUBB	$16,%CL
	NEGB	%CL
	SHLL	%CL,%EDX
	SHLL	%CL,%EDX
	SHRL	%CL,%EDX
	SHRL	%CL,%EDX
	ORL	%EDI,%EDX
	POPL	%ECX
	ANDL	$0xfffffffc,%ECX
	CALL	MEM_WRITE_WORD
	GOTONEXTCMD


a_rs4300i_sw:	GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX	#get SRCREG register content
	GETINDEX
	ADDL	%EBX,%ECX		#add offset to SRCREG  register content
	GETTARGREG
	MOVL	REG_OFS(%EBX),%EDX
        CALL	MEM_WRITE_WORD 		#[%ECX]=dl, write that adress
	GOTONEXTCMD


a_rs4300i_swr:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	GETINDEX
	ADDL	%EBX,%ECX
	MOVL	%ECX,%EDI
	PUSH	%ECX
	ANDL	$0xfffffffc,%ECX
        CALL	MEM_READ_WORD 	#dl=[%ECX], read that adress
	GETTARGREG
	MOVL	REG_OFS(%EBX),%ECX
	INC	%EDI
	XCHGL	%ECX,%EDI
	ANDL 	$3,%ECX
	SHLL	$2,%ECX
	SHRL	%CL,%EDX
	SHRL	%CL,%EDX
	SHLL	%CL,%EDX
	SHLL	%CL,%EDX
	SUBB	$16,%CL
	NEGB	%CL
	SHRL	%CL,%EDI
	SHRL	%CL,%EDI
	ORL	%EDI,%EDX
	POP	%ECX
	ANDL	$0xfffffffc,%ECX
	CALL	MEM_WRITE_WORD
	GOTONEXTCMD


a_rs4300i_cache:GOTONEXTCMD			#ignore it


a_rs4300i_ll:	GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX	#get SRCREG register content
	GETINDEX
	ADDL	%EBX,%ECX		#add offset to SRCREG  register content
        CALL	MEM_READ_WORD 	#dl=[%ECX], read that adress
	MOVL	CPR0_OFS+LLADDR,%EBX
	MOVL	%ECX,CPR0_OFS(%EBX)
	MOVL	$1,LL_BIT
	GETTARGREG
	MOVL	REG_OFS(%EBX),%EDX	
	GOTONEXTCMD


a_rs4300i_lwc1:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX	#get SRCREG register content
	GETINDEX
	ADDL	%EBX,%ECX		#add offset to SRCREG  register content
        CALL	MEM_READ_WORD
	GETFTARGREG
	MOVL	%EDX,CPR1_OFS(%EBX)
	SARL	$31,%EDX
	MOVL	%EDX,CPR1_OFS+4(%EBX)
	GOTONEXTCMD	

a_rs4300i_lwc2:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX	#get SRCREG register content
	GETINDEX
	ADDL	%EBX,%ECX		#add offset to SRCREG  register content
        CALL	MEM_READ_WORD 	#dl=[%ECX], read that adress
	GETTARGREG
	MOVL	CPR2_OFS(%EBX),%EDX
	GOTONEXTCMD	


a_rs4300i_lld:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX	#get SRCREG register content
	GETINDEX
	ADDL	%EBX,%ECX		#add offset to SRCREG  register content
        CALL	MEM_READ_DWORD 	#dl=[%ECX], read that adress
	PUSHL	%EBX
	MOVL	(CPR0_OFS+LLADDR),%EBX
	MOVL	%ECX,CPR0_OFS(%EBX)
	POPL	%EBX
	MOVL	$1,LL_BIT
	MOVL	%EAX,%ECX		#extract TARGREG register content
	SHRL	$13,%ECX
	ANDL	$248,%ECX
	MOVL	REG_OFS(%ECX),%EDX	
	MOVL	REG_OFS+4(%ECX),%EDX	
	GOTONEXTCMD


a_rs4300i_ldc1:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX	#get SRCREG register content
	GETINDEX
	ADDL	%EBX,%ECX		#add offset to SRCREG  register content
        CALL	MEM_READ_DWORD 	
	STOREFTARGDWORD
	GOTONEXTCMD	

a_rs4300i_ldc2:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX	#get SRCREG register content
	GETINDEX
	ADDL	%EBX,%ECX		#add offset to SRCREG  register content
        CALL	MEM_READ_DWORD 	#dl=[%ECX], read that adress
	PUSHL	%EBX
	GETTARGREG
	POPL	%ECX
	ANDL	$8,%EBX
	MOVL	CPR2_OFS(%ECX),%EDX
	MOVL	CPR2_OFS+4(%ECX),%EBX
	GOTONEXTCMD	




a_rs4300i_ld:	GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX	#get SRCREG register content
	GETINDEX
	ADDL	%EBX,%ECX		#add offset to SRCREG  register content
        CALL	MEM_READ_DWORD 	#%EBX:EDX=[%ECX], read that adress
	PUSHL	%EBX
	GETTARGREG
	POPL	%ECX
	MOVL	%EDX,REG_OFS(%EBX)
	MOVL	%ECX,REG_OFS+4(%EBX)
	GOTONEXTCMD


a_rs4300i_sc:	CMPL	$0,LL_BIT
	JE	a_rs4300i_SC1
	GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX	#get SRCREG register content
	GETINDEX
	ADDL	%EBX,%ECX		#add offset to SRCREG  register content
	GETTARGREG
	MOVL	REG_OFS(%EBX),%EDX
        CALL	MEM_WRITE_WORD 		#[%ECX]=dl, write that adress
a_rs4300i_SC1:GETTARGREG
	MOVL	LL_BIT,%ECX
	MOVL	%ECX,REG_OFS(%EBX)
	GOTONEXTCMD


a_rs4300i_swc1:
	GETFTARGREG
	MOVL	CPR1_OFS(%EBX),%EDX
	GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	GETINDEX
	ADDL	%EBX,%ECX
	CALL	MEM_WRITE_WORD
	GOTONEXTCMD


a_rs4300i_swc2:GETTARGREG
	MOVL	CPR2_OFS(%EBX),%EDX
	GETSRCREG
	MOVL	%EBX,%ECX
	GETINDEX
	ADDL	%EBX,%ECX
	CALL	MEM_WRITE_WORD
	GOTONEXTCMD


a_rs4300i_scd:CMPL	$0,LL_BIT
	JE	a_rs4300i_SCDL
	GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX	#get SRCREG register content
	GETINDEX
	ADDL	%EBX,%ECX		#add offset to SRCREG  register content
	GETTARGREG
	MOVL	REG_OFS(%EBX),%EDX
	MOVL	REG_OFS+4(%EBX),%EBX
        CALL	MEM_WRITE_DWORD 		#[%ECX]=dl, write that adress
a_rs4300i_SCDL:GETTARGREG
	MOVL	LL_BIT,%ECX
	MOVL	%ECX,REG_OFS(%EBX)
	GOTONEXTCMD



a_rs4300i_sdc1:
	GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	GETINDEX
	ADDL	%EBX,%ECX
	PUSHL	%ECX
	LOADFTARGDWORD
	POPL	%ECX
	CALL	MEM_WRITE_DWORD
	GOTONEXTCMD


a_rs4300i_sdc2:GETTARGREG
	MOVL	CPR2_OFS(%EBX),%EDX
	MOVL	CPR2_OFS+4(%EBX),%EBX
	PUSH %EBX
	GETSRCREG
	MOVL	%EBX,%ECX
	GETINDEX
	ADDL	%EBX,%ECX
	POPL	%EBX
	CALL	MEM_WRITE_WORD
	GOTONEXTCMD


a_rs4300i_sd:	GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX	#get SRCREG register content
	GETINDEX
	ADDL	%EBX,%ECX		#add offset to SRCREG  register content
	GETTARGREG
	MOVL	REG_OFS(%EBX),%EDX
	MOVL	REG_OFS+4(%EBX),%EBX
        CALL	MEM_WRITE_DWORD 		#[%ECX]=dl, write that adress
	GOTONEXTCMD

#----------------------------------------------------------------------------


a_rs4300i_special_sll:GETSA
	GETTARGREG
	MOVL	REG_OFS(%EBX),%EDX
	SHLL	%CL,%EDX
	GETDSTREG
	MOVL	%EDX,REG_OFS(%EBX)
	GOTONEXTCMD


a_rs4300i_special_srl:GETSA
	GETTARGREG
	MOVL	REG_OFS(%EBX),%EDX
	SHRL	%CL,%EDX
	GETDSTREG
	MOVL	%EDX,REG_OFS(%EBX)
	GOTONEXTCMD


a_rs4300i_special_sra:GETSA
	GETTARGREG
	MOVL	REG_OFS(%EBX),%EDX
	SARL	%CL,%EDX
	GETDSTREG
	MOVL	%EDX,REG_OFS(%EBX)
	GOTONEXTCMD


a_rs4300i_special_sllv:
	GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	ANDB	$0x1f,%CL
	GETTARGREG
	MOVL	REG_OFS(%EBX),%EDX
	SHLL	%CL,%EDX
	GETDSTREG
	MOVL	%EDX,REG_OFS(%EBX)
	SARL	$31,%EDX
	MOVL	%EDX,REG_OFS+4(%EBX)
	GOTONEXTCMD


a_rs4300i_special_srlv:
	GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	ANDB	$0x1f,%CL
	GETTARGREG
	MOVL	REG_OFS(%EBX),%EDX
	SHRL	%CL,%EDX
	GETDSTREG
	MOVL	%EDX,REG_OFS(%EBX)
	SARL	$31,%EDX
	MOVL	%EDX,REG_OFS+4(%EBX)
	GOTONEXTCMD


a_rs4300i_special_srav:
	GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	ANDB	$0x1f,%CL
	GETTARGREG
	MOVL	REG_OFS(%EBX),%EDX
	SARL	%CL,%EDX
	GETDSTREG
	MOVL	%EDX,REG_OFS(%EBX)
	SARL	$31,%EDX
	MOVL	%EDX,REG_OFS+4(%EBX)
	GOTONEXTCMD


a_rs4300i_special_jr:GETSRCREG
	MOVL	REG_OFS(%EBX),%EBX
	MOVL	%EBX,PC_DELAY
	MOVL	$1,DELAY	
	GOTONEXTCMD


a_rs4300i_special_jalr:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	MOVL	%ECX,PC_DELAY
	MOVL	$1,DELAY	
	MOVL	PC,%ECX
	ADDL	$8,%ECX	
	GETDSTREG
	MOVL	%ECX,REG_OFS(%EBX)
	GOTONEXTCMD


a_rs4300i_special_syscall:
	ORL	$RS4300I_DO_SYSCALL_EXCEPTION,DOSOMETHING
	GOTONEXTCMD


a_rs4300i_special_break:
	GOTONEXTCMD


a_rs4300i_special_sync:
	GOTONEXTCMD


a_rs4300i_special_mfhi:
	MOVL	(HI_OFS),%ECX
	MOVL	(HI_OFS+4),%EDX
	GETDSTREG
	MOVL	%ECX,REG_OFS(%EBX)
	MOVL	%EDX,REG_OFS+4(%EBX)
	GOTONEXTCMD


a_rs4300i_special_mthi:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	MOVL	REG_OFS+4(%EBX),%EDX
	MOVL	%ECX,(HI_OFS)
	MOVL	%EDX,(HI_OFS+4)
	GOTONEXTCMD


a_rs4300i_special_mflo:
	MOVL	(LO_OFS),%ECX
	MOVL	(LO_OFS+4),%EDX
	GETDSTREG
	MOVL	%ECX,REG_OFS(%EBX)
	MOVL	%EDX,REG_OFS+4(%EBX)
	GOTONEXTCMD


a_rs4300i_special_mtlo:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	MOVL	REG_OFS+4(%EBX),%EDX
	MOVL	%ECX,(LO_OFS)
	MOVL	%EDX,(LO_OFS+4)
	GOTONEXTCMD


a_rs4300i_special_dsll:
a_rs4300i_special_dsllv:  GETSRCREG
	MOVB	%BL,%CL
	ANDB	$31,%CL
	GETTARGREG
	MOVL	REG_OFS(%EBX),%EDX
	MOVL	REG_OFS+4(%EBX),%EBX
	SHLDL	%CL,%EDX,%EBX
	PUSHL	%EBX
	GETDSTREG
	POPL	%ECX
	MOVL	REG_OFS(%EBX),%EDX
	MOVL	REG_OFS+4(%EBX),%ECX
	GOTONEXTCMD


a_rs4300i_special_dsrl:
a_rs4300i_special_dsrlv:  GETSRCREG
	MOVB	%BL,%CL
	ANDB	$31,%CL
	GETTARGREG
	MOVL	REG_OFS(%EBX),%EDX
	MOVL	REG_OFS+4(%EBX),%EBX
	SHRDL	%CL,%EDX,%EBX
	PUSHL	%EBX
	GETDSTREG
	POPL	%ECX
	MOVL	REG_OFS(%EBX),%EDX
	MOVL	REG_OFS+4(%EBX),%ECX
	GOTONEXTCMD


a_rs4300i_special_dsra:
a_rs4300i_special_dsrav:  GETSRCREG
	MOVB	%BL,%CL
	ANDB	$31,%CL
	GETTARGREG
	MOVL	REG_OFS(%EBX),%EDX
	MOVL	REG_OFS+4(%EBX),%EBX
	SHRDL	%CL,%EDX,%EBX
	PUSHL	%EBX
	GETDSTREG
	POPL	%ECX
	MOVL	REG_OFS(%EBX),%EDX
	MOVL	REG_OFS+4(%EBX),%ECX
	GOTONEXTCMD


a_rs4300i_special_mult:GETSRCREG
	MOVL	REG_OFS(%EBX),%EDX
	GETTARGREG
	MOVL	REG_OFS(%EBX),%EAX
	IMUL	%EDX
	MOVL	%EAX,(LO_OFS)
	SARL	$31,%EAX
	MOVL	%EAX,(LO_OFS+4)
	MOVL	%EDX,(HI_OFS)
	SARL	$31,%EDX
	MOVL	%EDX,(HI_OFS+4)
	GOTONEXTCMD


a_rs4300i_special_multu:GETSRCREG
	MOVL	REG_OFS(%EBX),%EDX
	GETTARGREG
	MOVL	REG_OFS(%EBX),%EAX
	MULL	%EDX
	MOVL	%EAX,(LO_OFS)
	SARL	$31,%EAX
	MOVL	%EAX,(LO_OFS+4)
	MOVL	%EDX,(HI_OFS)
	SARL	$31,%EDX
	MOVL	%EDX,(HI_OFS+4)
	GOTONEXTCMD

a_rs4300i_special_div:GETTARGREG
	MOVL	REG_OFS(%EBX),%ECX
	GETSRCREG
	MOVL	REG_OFS(%EBX),%EAX
	CMPL	$0,%ECX
	JE	a_rs4300i_special_div1
	CLTD
	IDIV	%ECX
	MOVL	%EAX,(LO_OFS)
	SARL	$31,%EAX
	MOVL	%EAX,(LO_OFS+4)
	MOVL	%EDX,(HI_OFS)
	SARL	$31,%EDX
	MOVL	%EDX,(HI_OFS+4)
a_rs4300i_special_div1:
	GOTONEXTCMD

a_rs4300i_special_divu:GETTARGREG
	MOVL	REG_OFS(%EBX),%ECX
	GETSRCREG
	MOVL	REG_OFS(%EBX),%EAX
	CMPL	$0,%ECX
	JE	a_rs4300i_special_divu1
	DIV	%ECX
	MOVL	%EAX,(LO_OFS)
	SARL	$31,%EAX
	MOVL	%EAX,(LO_OFS+4)
	MOVL	%EDX,(HI_OFS)
	SARL	$31,%EDX
	MOVL	%EDX,(HI_OFS+4)
a_rs4300i_special_divu1:
	GOTONEXTCMD


a_rs4300i_special_dmult:
a_rs4300i_special_dmultu:GETTARGREG
	MOVL	REG_OFS(%EBX),%ECX
	MOVL	REG_OFS+4(%EBX),%EDX
	GETSRCREG
	MOVL	REG_OFS(%EBX),%EAX
	MOVL	REG_OFS+4(%EBX),%EBX
	PUSHL	%EAX
	PUSHL	%EDX
	IMULL	%ECX
	MOVL	%EAX,LO_OFS
	MOVL	%EDX,LO_OFS+4
	POPL	%EDX
	POPL	%EAX
	PUSHL	%EAX
	PUSHL	%EDX
	IMULL	%EDX
	MOVL	%EDX,HI_OFS
	ADDL	%EAX,LO_OFS+4
	ADCL	$0,HI_OFS
	POPL	%EDX
	POPL	%EAX
	MOVL	%EDX,%EAX
	MULL	%EBX
	MOVL	%EDX,HI_OFS+4
	ADDL	%EAX,HI_OFS
	ADCL	$0,HI_OFS+4
	MOVL	%EBX,%EAX
	MULL	%ECX
	ADDL	%EAX,LO_OFS+4
	ADCL	%EDX,HI_OFS
	ADCL	$0,HI_OFS+4
	GOTONEXTCMD

a_rs4300i_special_ddiv:GETTARGREG
	PUSHL	REG_OFS+4(%EBX)
	PUSHL	REG_OFS(%EBX)
	GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	MOVL	REG_OFS+4(%EBX),%EDX
	PUSHL	REG_OFS+4(%EBX)
	PUSHL	REG_OFS(%EBX)
	CMPL	$0,%ECX
	JNE	a_rs4300i_special_ddiv1
	CMPL	$0,%EDX
	JNE	a_rs4300i_special_ddiv1
	ADDL	$16,%ESP
	GOTONEXTCMD
a_rs4300i_special_ddiv1:
	CALL	__divdi3
	MOVL	%EAX,LO_OFS
	MOVL	%EDX,LO_OFS+4
	CALL	__moddi3
	MOVL	%EAX,HI_OFS
	MOVL	%EDX,HI_OFS+4
	ADDL	$16,%ESP
	GOTONEXTCMD


a_rs4300i_special_ddivu:GETTARGREG
	PUSHL	REG_OFS+4(%EBX)
	PUSHL	REG_OFS(%EBX)
	GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	MOVL	REG_OFS+4(%EBX),%EDX
	PUSHL	REG_OFS+4(%EBX)
	PUSHL	REG_OFS(%EBX)
	CMPL	$0,%ECX
	JNE	a_rs4300i_special_ddivu1
	CMPL	$0,%EDX
	JNE	a_rs4300i_special_ddivu1
	ADDL	$16,%ESP
	GOTONEXTCMD
a_rs4300i_special_ddivu1:
	CALL	__udivdi3
	MOVL	%EAX,LO_OFS
	MOVL	%EDX,LO_OFS+4
	CALL	__umoddi3
	MOVL	%EAX,HI_OFS
	MOVL	%EDX,HI_OFS+4
	ADDL	$16,%ESP
	GOTONEXTCMD

a_rs4300i_special_add:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	GETTARGREG
	ADDL	REG_OFS(%EBX),%ECX
	GETDSTREG
	MOVL	%ECX,REG_OFS(%EBX)
	SARL	$31,%ECX
	MOVL	%ECX,REG_OFS+4(%EBX)
	#exception
	GOTONEXTCMD	

a_rs4300i_special_addu:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	GETTARGREG
	ADDL	REG_OFS(%EBX),%ECX
	GETDSTREG
	MOVL	%ECX,REG_OFS(%EBX)
	SARL	$31,%ECX
	MOVL	%ECX,REG_OFS+4(%EBX)
	GOTONEXTCMD	
	
a_rs4300i_special_sub:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	GETTARGREG
	SUBL	REG_OFS(%EBX),%ECX
	GETDSTREG
	MOVL	%ECX,REG_OFS(%EBX)
	SARL	$31,%ECX
	MOVL	%ECX,REG_OFS+4(%EBX)
	#exception
	GOTONEXTCMD	

a_rs4300i_special_subu:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	GETTARGREG
	SUBL	REG_OFS(%EBX),%ECX
	GETDSTREG
	MOVL	%ECX,REG_OFS(%EBX)
	SARL	$31,%ECX
	MOVL	%ECX,REG_OFS+4(%EBX)
	GOTONEXTCMD	
	
a_rs4300i_special_and:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	MOVL	REG_OFS+4(%EBX),%EDX
	GETTARGREG
	ANDL	REG_OFS(%EBX),%ECX
	ANDL	REG_OFS+4(%EBX),%EDX
	GETDSTREG
	MOVL	%ECX,REG_OFS(%EBX)
	MOVL	%EDX,REG_OFS+4(%EBX)
	GOTONEXTCMD	

a_rs4300i_special_or:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	MOVL	REG_OFS+4(%EBX),%EDX
	GETTARGREG
	ORL	REG_OFS(%EBX),%ECX
	ORL	REG_OFS+4(%EBX),%EDX
	GETDSTREG
	MOVL	%ECX,REG_OFS(%EBX)
	MOVL	%EDX,REG_OFS+4(%EBX)
	GOTONEXTCMD	

a_rs4300i_special_xor:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	MOVL	REG_OFS+4(%EBX),%EDX
	GETTARGREG
	XORL	REG_OFS(%EBX),%ECX
	XORL	REG_OFS+4(%EBX),%EDX
	GETDSTREG
	MOVL	%ECX,REG_OFS(%EBX)
	MOVL	%EDX,REG_OFS+4(%EBX)
	GOTONEXTCMD	

a_rs4300i_special_nor:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	MOVL	REG_OFS+4(%EBX),%EDX
	GETTARGREG
	ORL	REG_OFS(%EBX),%ECX
	ORL	REG_OFS+4(%EBX),%EDX
	NOTL	%ECX
	NOTL	%EDX
	GETDSTREG
	MOVL	%ECX,REG_OFS(%EBX)
	MOVL	%EDX,REG_OFS+4(%EBX)
	GOTONEXTCMD	

a_rs4300i_special_slt:
	GETTARGREG
	MOVL	REG_OFS(%EBX),%ECX
	MOVL	REG_OFS+4(%EBX),%EDX
	GETSRCREG
	CMPL	%EDX,REG_OFS+4(%EBX)
	JL	a_rs4300i_special_slt1
	CMPL	%EDX,REG_OFS+4(%EBX)
	JNE	a_rs4300i_special_slt2
	CMPL	%ECX,REG_OFS(%EBX)
	JB	a_rs4300i_special_slt1
a_rs4300i_special_slt2:
	GETDSTREG
	MOVL	$0,REG_OFS+4(%EBX)
	MOVL	$0,REG_OFS(%EBX)
	GOTONEXTCMD
a_rs4300i_special_slt1:
	GETDSTREG
	MOVL	$0,REG_OFS+4(%EBX)
	MOVL	$1,REG_OFS(%EBX)
	GOTONEXTCMD

a_rs4300i_special_sltu:
	GETTARGREG
	MOVL	REG_OFS(%EBX),%ECX
	MOVL	REG_OFS+4(%EBX),%EDX
	GETSRCREG
	CMPL	%EDX,REG_OFS+4(%EBX)
	JB	a_rs4300i_special_sltu1
	CMPL	%EDX,REG_OFS+4(%EBX)
	JNE	a_rs4300i_special_sltu2
	CMPL	%ECX,REG_OFS(%EBX)
	JB	a_rs4300i_special_sltu1
a_rs4300i_special_sltu2:
	GETDSTREG
	MOVL	$0,REG_OFS+4(%EBX)
	MOVL	$0,REG_OFS(%EBX)
	GOTONEXTCMD
a_rs4300i_special_sltu1:
	GETDSTREG
	MOVL	$0,REG_OFS+4(%EBX)
	MOVL	$1,REG_OFS(%EBX)
	GOTONEXTCMD
	


a_rs4300i_special_dadd:
a_rs4300i_special_daddu:GETSRCREG
	MOVL	REG_OFS(%EBX),%EDX
	MOVL	REG_OFS+4(%EBX),%ECX
	GETTARGREG
	ADDL	REG_OFS(%EBX),%EDX
	ADCL	REG_OFS+4(%EBX),%ECX
	GETDSTREG
	MOVL	%EDX,REG_OFS(%EBX)
	MOVL	%ECX,REG_OFS+4(%EBX)
	GOTONEXTCMD

a_rs4300i_special_dsub:
a_rs4300i_special_dsubu:GETSRCREG
	MOVL	REG_OFS(%EBX),%EDX
	MOVL	REG_OFS+4(%EBX),%ECX
	GETTARGREG
	SUBL	REG_OFS(%EBX),%EDX
	SBBL	REG_OFS+4(%EBX),%ECX
	GETDSTREG
	MOVL	%EDX,REG_OFS(%EBX)
	MOVL	%ECX,REG_OFS+4(%EBX)
	GOTONEXTCMD


a_rs4300i_special_tge:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	GETTARGREG
	MOVL	$0,%EDX
	CMPL	REG_OFS(%EBX),%ECX
	JL	a_rs4300i_special_TGE1
	ORL	$RS4300I_DO_TRAP_EXCEPTION,DOSOMETHING
a_rs4300i_special_TGE1:
	GOTONEXTCMD	

a_rs4300i_special_tgeu:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	GETTARGREG
	MOVL	$0,%EDX
	CMPL	REG_OFS(%EBX),%ECX
	JB	a_rs4300i_special_TGEU1
	ORL	$RS4300I_DO_TRAP_EXCEPTION,DOSOMETHING
a_rs4300i_special_TGEU1:
	GOTONEXTCMD	

a_rs4300i_special_tlt:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	GETTARGREG
	MOVL	$0,%EDX
	CMPL	REG_OFS(%EBX),%ECX
	JL	a_rs4300i_special_TLT1
	ORL	$RS4300I_DO_TRAP_EXCEPTION,DOSOMETHING
a_rs4300i_special_TLT1:
	GOTONEXTCMD	

a_rs4300i_special_tltu:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	GETTARGREG
	MOVL	$0,%EDX
	CMPL	REG_OFS(%EBX),%ECX
	JAE	a_rs4300i_special_TLTU1
	ORL	$RS4300I_DO_TRAP_EXCEPTION,DOSOMETHING
a_rs4300i_special_TLTU1:
	GOTONEXTCMD	

a_rs4300i_special_teq:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	GETTARGREG
	MOVL	$0,%EDX
	CMPL	REG_OFS(%EBX),%ECX
	JNE	a_rs4300i_special_TEQ1
	ORL	$RS4300I_DO_TRAP_EXCEPTION,DOSOMETHING
a_rs4300i_special_TEQ1:
	GOTONEXTCMD	

a_rs4300i_special_tne:GETSRCREG
	MOVL	REG_OFS(%EBX),%ECX
	GETTARGREG
	MOVL	$0,%EDX
	CMPL	REG_OFS(%EBX),%ECX
	JE	a_rs4300i_special_TNE1
	ORL	$RS4300I_DO_TRAP_EXCEPTION,DOSOMETHING
a_rs4300i_special_TNE1:
	GOTONEXTCMD	

a_rs4300i_special_dsll32:
	GETTARGREG
	MOVL	REG_OFS(%EBX),%EDX
	MOVB	%BL,%CL
	SHLL	%CL,%EDX
	GETDSTREG
	MOVL	$0,REG_OFS(%EBX)
	MOVL	%EDX,REG_OFS+4(%EBX)
	GOTONEXTCMD

a_rs4300i_special_dsrl32:
	GETTARGREG
	MOVL	REG_OFS(%EBX),%EDX
	MOVB	%BL,%CL
	SHRL	%CL,%EDX
	GETDSTREG
	MOVL	$0,REG_OFS(%EBX)
	MOVL	%EDX,REG_OFS+4(%EBX)
	GOTONEXTCMD

a_rs4300i_special_dsra32:
	GETTARGREG
	MOVL	REG_OFS(%EBX),%EDX
	MOVB	%BL,%CL
	SARL	%CL,%EDX
	GETDSTREG
	MOVL	$0,REG_OFS(%EBX)
	MOVL	%EDX,REG_OFS+4(%EBX)
	GOTONEXTCMD

#---------------------------------------------------------------------------

a_rs4300i_regimm_bltz:GETSRCREG
	CMP	$0,REG_OFS(%EBX)
	JGE a_rs4300i_regimm_BLTZ1
	MOVL	PC,%ECX
	MOVL	%ECX,PC_DELAY
	ADDL	$4,PC_DELAY
	GETINDEX
	SHLL	$2,%EBX
	ADD	%EBX,PC_DELAY
	MOVL	$1,DELAY
a_rs4300i_regimm_BLTZ1:GOTONEXTCMD

a_rs4300i_regimm_bgez:GETSRCREG
	CMP	$0,REG_OFS(%EBX)
	JL a_rs4300i_regimm_BGEZ1
	MOVL	PC,%ECX
	MOVL	%ECX,PC_DELAY
	ADDL	$4,PC_DELAY
	GETINDEX
	SHLL	$2,%EBX
	ADD	%EBX,PC_DELAY
	MOVL	$1,DELAY
a_rs4300i_regimm_BGEZ1:GOTONEXTCMD

a_rs4300i_regimm_bltzl:GETSRCREG
	CMP	$0,REG_OFS(%EBX)
	JGE a_rs4300i_regimm_BLTZL1
	MOVL	PC,%ECX
	MOVL	%ECX,PC_DELAY
	ADDL	$4,PC_DELAY
	GETINDEX
	SHLL	$2,%EBX
	ADD	%EBX,PC_DELAY
	MOVL	$1,DELAY
a_rs4300i_regimm_BLTZL1:
	ADD	$4,PC
	GOTONEXTCMD

a_rs4300i_regimm_bgezl:GETSRCREG
	CMP	$0,REG_OFS(%EBX)
	JL a_rs4300i_regimm_BGEZL1
	MOVL	PC,%ECX
	MOVL	%ECX,PC_DELAY
	ADDL	$4,PC_DELAY
	GETINDEX
	SHLL	$2,%EBX
	ADD	%EBX,PC_DELAY
	MOVL	$1,DELAY
a_rs4300i_regimm_BGEZL1:
	ADD	$4,PC
	GOTONEXTCMD

a_rs4300i_regimm_tgei:
	GETINDEX
	MOVL	%EBX,%ECX
	GETSRCREG
	CMPL	REG_OFS(%EBX),%ECX
	JL a_rs4300i_regimm_TGE1
	ORL	$RS4300I_DO_TRAP_EXCEPTION,DOSOMETHING
a_rs4300i_regimm_TGE1:GOTONEXTCMD

a_rs4300i_regimm_tgeiu:
	GETINDEX
	MOVL	%EBX,%ECX
	GETSRCREG
	CMPL	REG_OFS(%EBX),%ECX
	JB a_rs4300i_regimm_TGIU1
	ORL	$RS4300I_DO_TRAP_EXCEPTION,DOSOMETHING
	#do trap execution
a_rs4300i_regimm_TGIU1:GOTONEXTCMD
	
a_rs4300i_regimm_tlti:
	GETINDEX
	MOVL	%EBX,%ECX
	GETSRCREG
	CMPL	REG_OFS(%EBX),%ECX
	JGE a_rs4300i_regimm_TLTI1
	#do trap execution
a_rs4300i_regimm_TLTI1:GOTONEXTCMD

a_rs4300i_regimm_tltiu:
	GETINDEX
	MOVL	%EBX,%ECX
	GETSRCREG
	CMPL	REG_OFS(%EBX),%ECX
	JAE a_rs4300i_regimm_TLTIU1
	#do trap execution
a_rs4300i_regimm_TLTIU1:GOTONEXTCMD

a_rs4300i_regimm_teqi:
	GETINDEX
	MOVL	%EBX,%ECX
	GETSRCREG
	CMPL	REG_OFS(%EBX),%ECX
	JNE a_rs4300i_regimm_TEQI1
	#do trap execution
a_rs4300i_regimm_TEQI1:GOTONEXTCMD

a_rs4300i_regimm_tnei:
	GETINDEX
	MOVL	%EBX,%ECX
	GETSRCREG
	CMPL	REG_OFS(%EBX),%ECX
	JE a_rs4300i_regimm_TNEI1
	#do trap execution
a_rs4300i_regimm_TNEI1:GOTONEXTCMD


a_rs4300i_regimm_bltzal:GETSRCREG
	MOVL	PC,%EBX
	ADDL	$8,%EBX
	MOVL	(REG_OFS+148),%EBX
	CMP	$0,REG_OFS(%EBX)
	JGE a_rs4300i_regimm_BLTZAL1
	MOVL	PC,%ECX
	MOVL	%ECX,PC_DELAY
	ADDL	$4,PC_DELAY
	GETINDEX
	SHLL	$2,%EBX
	ADD	%EBX,PC_DELAY
	MOVL	$1,DELAY
a_rs4300i_regimm_BLTZAL1:GOTONEXTCMD

a_rs4300i_regimm_bgezal:GETSRCREG
	MOVL	PC,%EBX
	ADDL	$8,%EBX
	MOVL	(REG_OFS+148),%EBX
	CMP	$0,REG_OFS(%EBX)
	JL a_rs4300i_regimm_BGEZAL1
	MOVL	PC,%ECX
	MOVL	%ECX,PC_DELAY
	ADDL	$4,PC_DELAY
	GETINDEX
	SHLL	$2,%EBX
	ADD	%EBX,PC_DELAY
	MOVL	$1,DELAY
a_rs4300i_regimm_BGEZAL1:GOTONEXTCMD

a_rs4300i_regimm_bltzall:GETSRCREG
	MOVL	PC,%EBX
	ADDL	$8,%EBX
	MOVL	(REG_OFS+148),%EBX
	CMP	$0,REG_OFS(%EBX)
	JGE a_rs4300i_regimm_BLTZALL1
	MOVL	PC,%ECX
	MOVL	%ECX,PC_DELAY
	ADDL	$4,PC_DELAY
	GETINDEX
	SHLL	$2,%EBX
	ADD	%EBX,PC_DELAY
	MOVL	$1,DELAY
a_rs4300i_regimm_BLTZALL1:
	ADD	$4,PC
	GOTONEXTCMD

a_rs4300i_regimm_bgezall:GETSRCREG
	MOVL	PC,%EBX
	ADDL	$8,%EBX
	MOVL	(REG_OFS+148),%EBX
	CMP	$0,REG_OFS(%EBX)
	JL a_rs4300i_regimm_BGEZALL1
	MOVL	PC,%ECX
	MOVL	%ECX,PC_DELAY
	ADDL	$4,PC_DELAY
	GETINDEX
	SHLL	$2,%EBX
	ADD	%EBX,PC_DELAY
	MOVL	$1,DELAY
a_rs4300i_regimm_BGEZALL1:
	ADD	$4,PC
	GOTONEXTCMD


#------------------------------------------------------------------------


