.text
.align 16


.globl render_image_16_to_06	# done
.globl render_image_16_to_15	# done
.globl render_image_16_to_16	# done
.globl render_image_16_to_24	# done
.globl render_image_16_to_32	# done

.globl render_image_32_to_06	# done
.globl render_image_32_to_15	# done
.globl render_image_32_to_16	# done
.globl render_image_32_to_24	# done
.globl render_image_32_to_32	# done


#define	SRCPTR	 32(%EBP)
#define	DSTPTR	 36(%EBP)
#define SRCSZX	 40(%EBP)
#define SRCSZY	 44(%EBP)
#define DSTSZX	 48(%EBP)
#define DSTSZY	 52(%EBP)
#define YWAG	 -4(%EBP)
#define XCNT	 -8(%EBP)
#define YCNT	-12(%EBP)





render_image_16_to_06:
	PUSHL	%EAX		#Save all registers
	PUSHL	%EBX
	PUSHL	%ECX
	PUSHL	%EDX
	PUSHL	%ESI
	PUSHL	%EDI
	PUSHL	%EBP
	MOVL	%ESP,%EBP	#To access stack
	CMPL	$0,SRCSZX
	JZ	LOOP16_6_Y3
	CMPL	$0,SRCSZY
	JZ	LOOP16_6_Y3
	MOVL	SRCPTR,%ESI	#Initialize Pointer to Source Bitmap
	MOVL	DSTPTR,%EDI	#Initialize Pointer to Destinaton Bitmap
        MOVL	SRCSZY,%EDX	#Initialize Counter to count Source Lines to stretch
	MOVL	%EDX,YCNT
	MOVL	DSTSZY,%EDX	#Initialize 'WAAGE' of Y-Direction
	MOVL	%EDX,YWAG
	JMP	LOOP16_6_Y1	#Jump to first comparison

LOOP16_6_Y:
	MOVL	SRCSZX,%EDX
	MOVL	%EDX,XCNT	#Initialize Column counter
	MOVL	DSTSZX,%EDX	#Initialize X-Weight
	JMP	LOOP16_6_X1	#jump to first comparison

LOOP16_6_X:
#ifdef ENDIAN_IS_LITTLE
	XORW	$2,%SI
#endif
	MOVW	(%ESI),%AX	#copy contents of one pixel
#ifdef ENDIAN_IS_LITTLE
	XORW	$2,%SI
#endif
        SHRW	$4,%AX		#modify red part
        MOVB	%AL,%BL
	ANDB	$3,%BL
	MOVB	%BL,%CL
	SHRW	$3,%AX		#modify green part
	MOVB	%AL,%BL
	ANDB	$12,%BL
	ORB	%BL,%CL
	SHRL	$3,%EAX		#modify	blue part
	MOVB	%AL,%BL
	ANDB	$48,%BX
	ORB	%BL,%CL
        MOVW	%CX,(%EDI)
        INC	%EDI		#increment destination pointer

LOOP16_6_X1:
	SUBL	SRCSZX,%EDX	#Decide whether to increment source or destination column
	JNS	LOOP16_6_X	#this will increment source column

LOOP16_6_X2:
	ADDL	$2,%ESI		#increment destination column
        DECL	XCNT		#one more column processed
        JZ	LOOP16_6_X3	#all column processed?
	ADDL	DSTSZX,%EDX	#put destination weight
        JNS	LOOP16_6_X	#weight still negative?
	JMP	LOOP16_6_X2	#go to draw destinations columns again

LOOP16_6_X3:
	SUBL	SRCSZX,%ESI	#rewind previous column
	SUBL	SRCSZX,%ESI

LOOP16_6_Y1:
	MOVL	SRCSZY,%EDX	#Decide whether to increment source or destination row
	SUBL	%EDX,YWAG
	JNS	LOOP16_6_Y	#jump to increment destination row

LOOP16_6_Y2:
	ADDL	SRCSZX,%ESI	#increment source row
	ADDL	SRCSZX,%ESI
	DECL	YCNT		#one more source row processed
	JZ	LOOP16_6_Y3	#all source rows processed?
	MOVL	DSTSZY,%EDX	#put destination weight on 'Waage'
	ADDL	%EDX,YWAG
	JNS	LOOP16_6_Y	#'Waage' still on negative side?
	JMP	LOOP16_6_Y2	# go to draw destination lines again

LOOP16_6_Y3:
	POPL	%EBP		#restore all registers
	POPL	%EDI
	POPL	%ESI
	POPL	%EDX
	POPL	%ECX
	POPL	%EBX
	POPL	%EAX
	RET			#return from routine
render_image_END_16_to_06:

render_image_16_to_15:
	PUSHL	%EAX		#Save all registers
	PUSHL	%EBX
	PUSHL	%ECX
	PUSHL	%EDX
	PUSHL	%ESI
	PUSHL	%EDI
	PUSHL	%EBP
	MOVL	%ESP,%EBP	#To access stack
	CMPL	$0,SRCSZX
	JZ	LOOP16_15_Y3
	CMPL	$0,SRCSZY
	JZ	LOOP16_15_Y3
	MOVL	SRCPTR,%ESI	#Initialize Pointer to Source Bitmap
	MOVL	DSTPTR,%EDI	#Initialize Pointer to Destinaton Bitmap
        MOVL	SRCSZY,%EDX	#Initialize Counter to count Source Lines to stretch
	MOVL	%EDX,YCNT
	MOVL	DSTSZY,%EDX	#Initialize 'WAAGE' of Y-Direction
	MOVL	%EDX,YWAG
	JMP	LOOP16_15_Y1	#Jump to first comparison

LOOP16_15_Y:
	MOVL	SRCSZX,%EDX
	MOVL	%EDX,XCNT	#Initialize Column counter
	MOVL	DSTSZX,%EDX	#Initialize X-Weight
	JMP	LOOP16_15_X1	#jump to first comparison

LOOP16_15_X:
#ifdef ENDIAN_IS_LITTLE
	XORW	$2,%SI
#endif
	MOVW	(%ESI),%AX	#copy contents of one pixel
#ifdef ENDIAN_IS_LITTLE
	XORW	$2,%SI
#endif
	SHRW	$1,%AX
        MOVW	%AX,(%EDI)
        ADDL	$2,%EDI		#increment destination pointer

LOOP16_15_X1:
	SUBL	SRCSZX,%EDX	#Decide whether to increment source or destination column
	JNS	LOOP16_15_X	#this will increment source column

LOOP16_15_X2:
	ADDL	$2,%ESI		#increment destination column
        DECL	XCNT		#one more column processed
        JZ	LOOP16_15_X3	#all column processed?
	ADDL	DSTSZX,%EDX	#put destination weight
        JNS	LOOP16_15_X	#weight still negative?
	JMP	LOOP16_15_X2	#go to draw destinations columns again

LOOP16_15_X3:
	SUBL	SRCSZX,%ESI	#rewind previous column
	SUBL	SRCSZX,%ESI	


LOOP16_15_Y1:
	MOVL	SRCSZY,%EDX	#Decide whether to increment source or destination row
	SUBL	%EDX,YWAG
	JNS	LOOP16_15_Y	#jump to increment destination row

LOOP16_15_Y2:
	ADDL	SRCSZX,%ESI	#increment source row
	ADDL	SRCSZX,%ESI
	DECL	YCNT		#one more source row processed
	JZ	LOOP16_15_Y3	#all source rows processed?
	MOVL	DSTSZY,%EDX	#put destination weight on 'Waage'
	ADDL	%EDX,YWAG
	JNS	LOOP16_15_Y	#'Waage' still on negative side?
	JMP	LOOP16_15_Y2	# go to draw destination lines again

LOOP16_15_Y3:
	POPL	%EBP		#restore all registers
	POPL	%EDI
	POPL	%ESI
	POPL	%EDX
	POPL	%ECX
	POPL	%EBX
	POPL	%EAX
	RET			#return from routine
render_image_END_16_to_15:


render_image_16_to_16:
	PUSHL	%EAX		#Save all registers
	PUSHL	%EBX
	PUSHL	%ECX
	PUSHL	%EDX
	PUSHL	%ESI
	PUSHL	%EDI
	PUSHL	%EBP
	MOVL	%ESP,%EBP	#To access stack
	CMPL	$0,SRCSZX
	JZ	LOOP16_16_Y3
	CMPL	$0,SRCSZY
	JZ	LOOP16_16_Y3
	MOVL	SRCPTR,%ESI	#Initialize Pointer to Source Bitmap
	MOVL	DSTPTR,%EDI	#Initialize Pointer to Destinaton Bitmap
        MOVL	SRCSZY,%EDX	#Initialize Counter to count Source Lines to stretch
	MOVL	%EDX,YCNT
	MOVL	DSTSZY,%EDX	#Initialize 'WAAGE' of Y-Direction
	MOVL	%EDX,YWAG
	JMP	LOOP16_16_Y1	#Jump to first comparison

LOOP16_16_Y:
	MOVL	SRCSZX,%EDX
	MOVL	%EDX,XCNT	#Initialize Column counter
	MOVL	DSTSZX,%EDX	#Initialize X-Weight
	JMP	LOOP16_16_X1	#jump to first comparison

LOOP16_16_X:
#ifdef ENDIAN_IS_LITTLE
	XORW	$2,%SI
#endif
	MOVW	(%ESI),%AX	#copy contents of one pixel
#ifdef ENDIAN_IS_LITTLE
	XORW	$2,%SI
#endif
	MOVW	%AX,%CX
	ANDW	$65472,%CX
	SHRW	$1,%AX
	ANDW	$31,%AX
	ORW	%AX,%CX
        MOVW	%CX,(%EDI)
        ADDL	$2,%EDI		#increment destination pointer

LOOP16_16_X1:
	SUBL	SRCSZX,%EDX	#Decide whether to increment source or destination column
	JNS	LOOP16_16_X	#this will increment source column

LOOP16_16_X2:
	ADDL	$2,%ESI		#increment destination column
        DECL	XCNT		#one more column processed
        JZ	LOOP16_16_X3	#all column processed?
	ADDL	DSTSZX,%EDX	#put destination weight
        JNS	LOOP16_16_X	#weight still negative?
	JMP	LOOP16_16_X2	#go to draw destinations columns again

LOOP16_16_X3:
	SUBL	SRCSZX,%ESI	#rewind previous column
	SUBL	SRCSZX,%ESI

LOOP16_16_Y1:
	MOVL	SRCSZY,%EDX	#Decide whether to increment source or destination row
	SUBL	%EDX,YWAG
	JNS	LOOP16_16_Y	#jump to increment destination row

LOOP16_16_Y2:
	ADDL	SRCSZX,%ESI	#increment source row
	ADDL	SRCSZX,%ESI
	DECL	YCNT		#one more source row processed
	JZ	LOOP16_16_Y3	#all source rows processed?
	MOVL	DSTSZY,%EDX	#put destination weight on 'Waage'
	ADDL	%EDX,YWAG
	JNS	LOOP16_16_Y	#'Waage' still on negative side?
	JMP	LOOP16_16_Y2	# go to draw destination lines again

LOOP16_16_Y3:
	POPL	%EBP		#restore all registers
	POPL	%EDI
	POPL	%ESI
	POPL	%EDX
	POPL	%ECX
	POPL	%EBX
	POPL	%EAX
	RET			#return from routine
render_image_END_16_to_16:



render_image_16_to_24:
	PUSHL	%EAX		#Save all registers
	PUSHL	%EBX
	PUSHL	%ECX
	PUSHL	%EDX
	PUSHL	%ESI
	PUSHL	%EDI
	PUSHL	%EBP
	MOVL	%ESP,%EBP	#To access stack
	CMPL	$0,SRCSZX
	JZ	LOOP16_24_Y3
	CMPL	$0,SRCSZY
	JZ	LOOP16_24_Y3
	MOVL	SRCPTR,%ESI	#Initialize Pointer to Source Bitmap
	MOVL	DSTPTR,%EDI	#Initialize Pointer to Destinaton Bitmap
        MOVL	SRCSZY,%EDX	#Initialize Counter to count Source Lines to stretch
	MOVL	%EDX,YCNT
	MOVL	DSTSZY,%EDX	#Initialize 'WAAGE' of Y-Direction
	MOVL	%EDX,YWAG
	JMP	LOOP16_24_Y1	#Jump to first comparison

LOOP16_24_Y:
	MOVL	SRCSZX,%EDX
	MOVL	%EDX,XCNT	#Initialize Column counter
	MOVL	DSTSZX,%EDX	#Initialize X-Weight
	JMP	LOOP16_24_X1	#jump to first comparison

LOOP16_24_X:
	MOVL	$0,%EAX
#ifdef ENDIAN_IS_LITTLE
	XORW	$2,%SI
#endif
	MOVW	(%ESI),%AX	#copy contents of one pixel
#ifdef ENDIAN_IS_LITTLE
	XORW	$2,%SI
#endif
	SHLL	$2,%EAX
	MOVL	%EAX,%EBX
	ANDL	$248,%EBX
	MOVL	%EBX,%ECX
	MOVL	%EAX,%EBX
	SHLL	$3,%BX
	ANDL	$64512,%BX
	ORL	%EBX,%ECX
	SHLL	$3,%EAX
	MOVL	%EAX,%EBX
	ANDL	$16252928,%EBX
	ORL	%EBX,%ECX
	MOVW	%CX,(%EDI)
	SHRL	$8,%ECX
	ADDL	$2,%EDI
	MOVB	%CH,(%EDI)
	ADDL	$1,%EDI		#increment destination pointer

LOOP16_24_X1:
	SUBL	SRCSZX,%EDX	#Decide whether to increment source or destination column
	JNS	LOOP16_24_X	#this will increment source column

LOOP16_24_X2:
	ADDL	$2,%ESI		#increment destination column
        DECL	XCNT		#one more column processed
        JZ	LOOP16_24_X3	#all column processed?
	ADDL	DSTSZX,%EDX	#put destination weight
        JNS	LOOP16_24_X	#weight still negative?
	JMP	LOOP16_24_X2	#go to draw destinations columns again

LOOP16_24_X3:
	SUBL	SRCSZX,%ESI	#rewind previous column
	SUBL	SRCSZX,%ESI

LOOP16_24_Y1:
	MOVL	SRCSZY,%EDX	#Decide whether to increment source or destination row
	SUBL	%EDX,YWAG
	JNS	LOOP16_24_Y	#jump to increment destination row

LOOP16_24_Y2:
	ADDL	SRCSZX,%ESI	#increment source row
	ADDL	SRCSZX,%ESI
	DECL	YCNT		#one more source row processed
	JZ	LOOP16_24_Y3	#all source rows processed?
	MOVL	DSTSZY,%EDX	#put destination weight on 'Waage'
	ADDL	%EDX,YWAG
	JNS	LOOP16_24_Y	#'Waage' still on negative side?
	JMP	LOOP16_24_Y2	# go to draw destination lines again

LOOP16_24_Y3:
	POPL	%EBP		#restore all registers
	POPL	%EDI
	POPL	%ESI
	POPL	%EDX
	POPL	%ECX
	POPL	%EBX
	POPL	%EAX
	RET			#return from routine
render_image_END_16_to_24:



render_image_16_to_32:
	PUSHL	%EAX		#Save all registers
	PUSHL	%EBX
	PUSHL	%ECX
	PUSHL	%EDX
	PUSHL	%ESI
	PUSHL	%EDI
	PUSHL	%EBP
	MOVL	%ESP,%EBP	#To access stack
	CMPL	$0,SRCSZX
	JZ	LOOP16_32_Y3
	CMPL	$0,SRCSZY
	JZ	LOOP16_32_Y3
	MOVL	SRCPTR,%ESI	#Initialize Pointer to Source Bitmap
	MOVL	DSTPTR,%EDI	#Initialize Pointer to Destinaton Bitmap
        MOVL	SRCSZY,%EDX	#Initialize Counter to count Source Lines to stretch
	MOVL	%EDX,YCNT
	MOVL	DSTSZY,%EDX	#Initialize 'WAAGE' of Y-Direction
	MOVL	%EDX,YWAG
	JMP	LOOP16_32_Y1	#Jump to first comparison

LOOP16_32_Y:
	MOVL	SRCSZX,%EDX
	MOVL	%EDX,XCNT	#Initialize Column counter
	MOVL	DSTSZX,%EDX	#Initialize X-Weight
	JMP	LOOP16_32_X1	#jump to first comparison

LOOP16_32_X:
	MOVL	$0,%EAX
#ifdef ENDIAN_IS_LITTLE
	XORW	$2,%SI
#endif
	MOVW	(%ESI),%AX	#copy contents of one pixel
#ifdef ENDIAN_IS_LITTLE
	XORW	$2,%SI
#endif
	SHLL	$2,%EAX
	MOVL	%EAX,%EBX
	ANDL	$248,%EBX
	MOVL	%EBX,%ECX
	MOVL	%EAX,%EBX
	SHLL	$3,%BX
	ANDL	$64512,%BX
	ORL	%EBX,%ECX
	SHLL	$3,%EAX
	MOVL	%EAX,%EBX
	ANDL	$16252928,%EBX
	ORL	%EBX,%ECX
        MOVL	%CX,(%EDI)
        ADDL	$4,%EDI		#increment destination pointer

LOOP16_32_X1:
	SUBL	SRCSZX,%EDX	#Decide whether to increment source or destination column
	JNS	LOOP16_32_X	#this will increment source column

LOOP16_32_X2:
	ADDL	$2,%ESI		#increment destination column
        DECL	XCNT		#one more column processed
        JZ	LOOP16_32_X3	#all column processed?
	ADDL	DSTSZX,%EDX	#put destination weight
        JNS	LOOP16_32_X	#weight still negative?
	JMP	LOOP16_32_X2	#go to draw destinations columns again

LOOP16_32_X3:
	SUBL	SRCSZX,%ESI	#rewind previous column
	SUBL	SRCSZX,%ESI

LOOP16_32_Y1:
	MOVL	SRCSZY,%EDX	#Decide whether to increment source or destination row
	SUBL	%EDX,YWAG
	JNS	LOOP16_32_Y	#jump to increment destination row

LOOP16_32_Y2:
	ADDL	SRCSZX,%ESI	#increment source row
	ADDL	SRCSZX,%ESI
	DECL	YCNT		#one more source row processed
	JZ	LOOP16_32_Y3	#all source rows processed?
	MOVL	DSTSZY,%EDX	#put destination weight on 'Waage'
	ADDL	%EDX,YWAG
	JNS	LOOP16_32_Y	#'Waage' still on negative side?
	JMP	LOOP16_32_Y2	# go to draw destination lines again

LOOP16_32_Y3:
	POPL	%EBP		#restore all registers
	POPL	%EDI
	POPL	%ESI
	POPL	%EDX
	POPL	%ECX
	POPL	%EBX
	POPL	%EAX
	RET			#return from routine
render_image_END_16_to_32:





render_image_32_to_06:
	PUSHL	%EAX		#Save all registers
	PUSHL	%EBX
	PUSHL	%ECX
	PUSHL	%EDX
	PUSHL	%ESI
	PUSHL	%EDI
	PUSHL	%EBP
	MOVL	%ESP,%EBP	#To access stack
	CMPL	$0,SRCSZX
	JZ	LOOP32_6_Y3
	CMPL	$0,SRCSZY
	JZ	LOOP32_6_Y3
	MOVL	SRCPTR,%ESI	#Initialize Pointer to Source Bitmap
	MOVL	DSTPTR,%EDI	#Initialize Pointer to Destinaton Bitmap
        MOVL	SRCSZY,%EDX	#Initialize Counter to count Source Lines to stretch
	MOVL	%EDX,YCNT
	MOVL	DSTSZY,%EDX	#Initialize 'WAAGE' of Y-Direction
	MOVL	%EDX,YWAG
	JMP	LOOP32_6_Y1	#Jump to first comparison

LOOP32_6_Y:
	MOVL	SRCSZX,%EDX
	MOVL	%EDX,XCNT	#Initialize Column counter
	MOVL	DSTSZX,%EDX	#Initialize X-Weight
	JMP	LOOP32_6_X1	#jump to first comparison

LOOP32_6_X:
	MOVL	(%ESI),%EAX	#copy contents of one pixel
        SHRL	$6,%EAX		#modify red part
        MOVB	%AL,%BL
	ANDB	$3,%BL
	MOVB	%BL,%CL
	SHRL	$6,%AX		#modify green part
	MOVB	%AL,%BL
	ANDB	$12,%BL
	ORB	%BL,%CL
	SHRL	$6,%EAX		#modify	blue part
	MOVB	%AL,%BL
	ANDB	$48,%BX
	ORB	%BL,%CL
        MOVB	%CL,(%EDI)
        INC	%EDI		#increment destination pointer

LOOP32_6_X1:
	SUBL	SRCSZX,%EDX	#Decide whether to increment source or destination column
	JNS	LOOP32_6_X	#this will increment source column

LOOP32_6_X2:
	ADDL	$2,%ESI		#increment destination column
        DECL	XCNT		#one more column processed
        JZ	LOOP32_6_X3	#all column processed?
	ADDL	DSTSZX,%EDX	#put destination weight
        JNS	LOOP32_6_X	#weight still negative?
	JMP	LOOP32_6_X2	#go to draw destinations columns again

LOOP32_6_X3:
	SUBL	SRCSZX,%ESI	#rewind previous column
	SUBL	SRCSZX,%ESI
	SUBL	SRCSZX,%ESI
	SUBL	SRCSZX,%ESI

LOOP32_6_Y1:
	MOVL	SRCSZY,%EDX	#Decide whether to increment source or destination row
	SUBL	%EDX,YWAG
	JNS	LOOP32_6_Y	#jump to increment destination row

LOOP32_6_Y2:
	ADDL	SRCSZX,%ESI	#increment source row
	ADDL	SRCSZX,%ESI
	ADDL	SRCSZX,%ESI
	ADDL	SRCSZX,%ESI
	DECL	YCNT		#one more source row processed
	JZ	LOOP32_6_Y3	#all source rows processed?
	MOVL	DSTSZY,%EDX	#put destination weight on 'Waage'
	ADDL	%EDX,YWAG
	JNS	LOOP32_6_Y	#'Waage' still on negative side?
	JMP	LOOP32_6_Y2	# go to draw destination lines again

LOOP32_6_Y3:
	POPL	%EBP		#restore all registers
	POPL	%EDI
	POPL	%ESI
	POPL	%EDX
	POPL	%ECX
	POPL	%EBX
	POPL	%EAX
	RET			#return from routine
render_image_END_32_to_06:





render_image_32_to_15:
	PUSHL	%EAX		#Save all registers
	PUSHL	%EBX
	PUSHL	%ECX
	PUSHL	%EDX
	PUSHL	%ESI
	PUSHL	%EDI
	PUSHL	%EBP
	MOVL	%ESP,%EBP	#To access stack
	CMPL	$0,SRCSZX
	JZ	LOOP32_15_Y3
	CMPL	$0,SRCSZY
	JZ	LOOP32_15_Y3
	MOVL	SRCPTR,%ESI	#Initialize Pointer to Source Bitmap
	MOVL	DSTPTR,%EDI	#Initialize Pointer to Destinaton Bitmap
        MOVL	SRCSZY,%EDX	#Initialize Counter to count Source Lines to stretch
	MOVL	%EDX,YCNT
	MOVL	DSTSZY,%EDX	#Initialize 'WAAGE' of Y-Direction
	MOVL	%EDX,YWAG
	JMP	LOOP32_15_Y1	#Jump to first comparison

LOOP32_15_Y:
	MOVL	SRCSZX,%EDX
	MOVL	%EDX,XCNT	#Initialize Column counter
	MOVL	DSTSZX,%EDX	#Initialize X-Weight
	JMP	LOOP32_15_X1	#jump to first comparison

LOOP32_15_X:
	MOVL	(%ESI),%EAX	#copy contents of one pixel
        SHRL	$3,%EAX		#modify red part
        MOVW	%AX,%BX
	ANDW	$31,%BX
	MOVW	%BX,%CX
	SHRL	$3,%EAX		#modify green part
	MOVW	%AX,%BX
	ANDW	$992,%BX
	ORW	%BX,%CX
	SHRL	$3,%EAX		#modify	blue part
	MOVW	%AX,%BX
	ANDW	$31744,%BX
	ORW	%BX,%CX
        MOVL	%ECX,(%EDI)
        ADDL	$2,%EDI		#increment destination pointer

LOOP32_15_X1:
	SUBL	SRCSZX,%EDX	#Decide whether to increment source or destination column
	JNS	LOOP32_15_X	#this will increment source column

LOOP32_15_X2:
	ADDL	$4,%ESI		#increment destination column
        DECL	XCNT		#one more column processed
        JZ	LOOP32_15_X3	#all column processed?
	ADDL	DSTSZX,%EDX	#put destination weight
        JNS	LOOP32_15_X	#weight still negative?
	JMP	LOOP32_15_X2	#go to draw destinations columns again

LOOP32_15_X3:
	SUBL	SRCSZX,%ESI	#rewind previous column
	SUBL	SRCSZX,%ESI
	SUBL	SRCSZX,%ESI	
	SUBL	SRCSZX,%ESI

LOOP32_15_Y1:
	MOVL	SRCSZY,%EDX	#Decide whether to increment source or destination row
	SUBL	%EDX,YWAG
	JNS	LOOP32_15_Y	#jump to increment destination row

LOOP32_15_Y2:
	ADDL	SRCSZX,%ESI	#increment source row
	ADDL	SRCSZX,%ESI
	ADDL	SRCSZX,%ESI
	ADDL	SRCSZX,%ESI
	DECL	YCNT		#one more source row processed
	JZ	LOOP32_15_Y3	#all source rows processed?
	MOVL	DSTSZY,%EDX	#put destination weight on 'Waage'
	ADDL	%EDX,YWAG
	JNS	LOOP32_15_Y	#'Waage' still on negative side?
	JMP	LOOP32_15_Y2	# go to draw destination lines again

LOOP32_15_Y3:
	POPL	%EBP		#restore all registers
	POPL	%EDI
	POPL	%ESI
	POPL	%EDX
	POPL	%ECX
	POPL	%EBX
	POPL	%EAX
	RET			#return from routine
render_image_END_32_to_15:





render_image_32_to_16:
	PUSHL	%EAX		#Save all registers
	PUSHL	%EBX
	PUSHL	%ECX
	PUSHL	%EDX
	PUSHL	%ESI
	PUSHL	%EDI
	PUSHL	%EBP
	MOVL	%ESP,%EBP	#To access stack
	CMPL	$0,SRCSZX
	JZ	LOOP32_16_Y3
	CMPL	$0,SRCSZY
	JZ	LOOP32_16_Y3
	MOVL	SRCPTR,%ESI	#Initialize Pointer to Source Bitmap
	MOVL	DSTPTR,%EDI	#Initialize Pointer to Destinaton Bitmap
        MOVL	SRCSZY,%EDX	#Initialize Counter to count Source Lines to stretch
	MOVL	%EDX,YCNT
	MOVL	DSTSZY,%EDX	#Initialize 'WAAGE' of Y-Direction
	MOVL	%EDX,YWAG
	JMP	LOOP32_16_Y1	#Jump to first comparison

LOOP32_16_Y:
	MOVL	SRCSZX,%EDX
	MOVL	%EDX,XCNT	#Initialize Column counter
	MOVL	DSTSZX,%EDX	#Initialize X-Weight
	JMP	LOOP32_16_X1	#jump to first comparison

LOOP32_16_X:
	MOVL	(%ESI),%EAX	#copy contents of one pixel
        SHRL	$3,%EAX		#modify red part
        MOVW	%AX,%BX
	ANDW	$31,%BX
	MOVW	%BX,%CX
	SHRL	$2,%EAX		#modify green part
	MOVW	%AX,%BX
	ANDW	$2016,%BX
	ORW	%BX,%CX
	SHRL	$3,%EAX		#modify	blue part
	MOVW	%AX,%BX
	ANDW	$63488,%BX
	ORW	%BX,%CX
        MOVL	%ECX,(%EDI)
        ADDL	$2,%EDI		#increment destination pointer

LOOP32_16_X1:
	SUBL	SRCSZX,%EDX	#Decide whether to increment source or destination column
	JNS	LOOP32_16_X	#this will increment source column

LOOP32_16_X2:
	ADDL	$4,%ESI		#increment destination column
        DECL	XCNT		#one more column processed
        JZ	LOOP32_16_X3	#all column processed?
	ADDL	DSTSZX,%EDX	#put destination weight
        JNS	LOOP32_16_X	#weight still negative?
	JMP	LOOP32_16_X2	#go to draw destinations columns again

LOOP32_16_X3:
	SUBL	SRCSZX,%ESI	#rewind previous column
	SUBL	SRCSZX,%ESI
	SUBL	SRCSZX,%ESI	
	SUBL	SRCSZX,%ESI

LOOP32_16_Y1:
	MOVL	SRCSZY,%EDX	#Decide whether to increment source or destination row
	SUBL	%EDX,YWAG
	JNS	LOOP32_16_Y	#jump to increment destination row

LOOP32_16_Y2:
	ADDL	SRCSZX,%ESI	#increment source row
	ADDL	SRCSZX,%ESI
	ADDL	SRCSZX,%ESI
	ADDL	SRCSZX,%ESI
	DECL	YCNT		#one more source row processed
	JZ	LOOP32_16_Y3	#all source rows processed?
	MOVL	DSTSZY,%EDX	#put destination weight on 'Waage'
	ADDL	%EDX,YWAG
	JNS	LOOP32_16_Y	#'Waage' still on negative side?
	JMP	LOOP32_16_Y2	# go to draw destination lines again

LOOP32_16_Y3:
	POPL	%EBP		#restore all registers
	POPL	%EDI
	POPL	%ESI
	POPL	%EDX
	POPL	%ECX
	POPL	%EBX
	POPL	%EAX
	RET			#return from routine
render_image_END_32_to_16:


render_image_32_to_24:
	PUSHL	%EAX		#Save all registers
	PUSHL	%EBX
	PUSHL	%ECX
	PUSHL	%EDX
	PUSHL	%ESI
	PUSHL	%EDI
	PUSHL	%EBP
	MOVL	%ESP,%EBP	#To access stack
	CMPL	$0,SRCSZX
	JZ	LOOP32_24_Y3
	CMPL	$0,SRCSZY
	JZ	LOOP32_24_Y3
	MOVL	SRCPTR,%ESI	#Initialize Pointer to Source Bitmap
	MOVL	DSTPTR,%EDI	#Initialize Pointer to Destinaton Bitmap
        MOVL	SRCSZY,%EDX	#Initialize Counter to count Source Lines to stretch
	MOVL	%EDX,YCNT
	MOVL	DSTSZY,%EDX	#Initialize 'WAAGE' of Y-Direction
	MOVL	%EDX,YWAG
	JMP	LOOP32_24_Y1	#Jump to first comparison

LOOP32_24_Y:
	MOVL	SRCSZX,%EDX
	MOVL	%EDX,XCNT	#Initialize Column counter
	MOVL	DSTSZX,%EDX	#Initialize X-Weight
	JMP	LOOP32_24_X1	#jump to first comparison

LOOP32_24_X:
	MOVL	(%ESI),%EAX	#copy contents of one pixel
	MOVW	%AX,(%EDI)
	MOVB	8,%CL
	SHRL	%CL,%EAX
	ADDL	$2,%EDI
	MOVB	%AH,(%EDI)
	ADDL	$1,%EDI		#increment destination pointer

LOOP32_24_X1:
	SUBL	SRCSZX,%EDX	#Decide whether to increment source or destination column
	JNS	LOOP32_24_X	#this will increment source column

LOOP32_24_X2:
	ADDL	$4,%ESI		#increment destination column
        DECL	XCNT		#one more column processed
        JZ	LOOP32_24_X3	#all column processed?
	ADDL	DSTSZX,%EDX	#put destination weight
        JNS	LOOP32_24_X	#weight still negative?
	JMP	LOOP32_24_X2	#go to draw destinations columns again

LOOP32_24_X3:
	SUBL	SRCSZX,%ESI	#rewind previous column
	SUBL	SRCSZX,%ESI
	SUBL	SRCSZX,%ESI
	SUBL	SRCSZX,%ESI

LOOP32_24_Y1:
	MOVL	SRCSZY,%EDX	#Decide whether to increment source or destination row
	SUBL	%EDX,YWAG
	JNS	LOOP32_24_Y	#jump to increment destination row

LOOP32_24_Y2:
	ADDL	SRCSZX,%ESI	#increment source row
	ADDL	SRCSZX,%ESI
	ADDL	SRCSZX,%ESI
	ADDL	SRCSZX,%ESI
	DECL	YCNT		#one more source row processed
	JZ	LOOP32_24_Y3	#all source rows processed?
	MOVL	DSTSZY,%EDX	#put destination weight on 'Waage'
	ADDL	%EDX,YWAG
	JNS	LOOP32_24_Y	#'Waage' still on negative side?
	JMP	LOOP32_24_Y2	# go to draw destination lines again

LOOP32_24_Y3:
	POPL	%EBP		#restore all registers
	POPL	%EDI
	POPL	%ESI
	POPL	%EDX
	POPL	%ECX
	POPL	%EBX
	POPL	%EAX
	RET			#return from routine
render_image_END_32_to_24:





render_image_32_to_32:
	PUSHL	%EAX		#Save all registers
	PUSHL	%EBX
	PUSHL	%ECX
	PUSHL	%EDX
	PUSHL	%ESI
	PUSHL	%EDI
	PUSHL	%EBP
	MOVL	%ESP,%EBP	#To access stack
	CMPL	$0,SRCSZX
	JZ	LOOP32_32_Y3
	CMPL	$0,SRCSZY
	JZ	LOOP32_32_Y3
	MOVL	SRCPTR,%ESI	#Initialize Pointer to Source Bitmap
	MOVL	DSTPTR,%EDI	#Initialize Pointer to Destinaton Bitmap
        MOVL	SRCSZY,%EDX	#Initialize Counter to count Source Lines to stretch
	MOVL	%EDX,YCNT
	MOVL	DSTSZY,%EDX	#Initialize 'WAAGE' of Y-Direction
	MOVL	%EDX,YWAG
	JMP	LOOP32_32_Y1	#Jump to first comparison

LOOP32_32_Y:
	MOVL	SRCSZX,%EDX
	MOVL	%EDX,XCNT	#Initialize Column counter
	MOVL	DSTSZX,%EDX	#Initialize X-Weight
	JMP	LOOP32_32_X1	#jump to first comparison

LOOP32_32_X:
	MOVL	(%ESI),%EAX	#copy contents of one pixel
        MOVL	%EAX,(%EDI)
        ADDL	$4,%EDI		#increment destination pointer

LOOP32_32_X1:
	SUBL	SRCSZX,%EDX	#Decide whether to increment source or destination column
	JNS	LOOP32_32_X	#this will increment source column

LOOP32_32_X2:
	ADDL	$4,%ESI		#increment destination column
        DECL	XCNT		#one more column processed
        JZ	LOOP32_32_X3	#all column processed?
	ADDL	DSTSZX,%EDX	#put destination weight
        JNS	LOOP32_32_X	#weight still negative?
	JMP	LOOP32_32_X2	#go to draw destinations columns again

LOOP32_32_X3:
	SUBL	SRCSZX,%ESI	#rewind previous column
	SUBL	SRCSZX,%ESI
	SUBL	SRCSZX,%ESI	
	SUBL	SRCSZX,%ESI

LOOP32_32_Y1:
	MOVL	SRCSZY,%EDX	#Decide whether to increment source or destination row
	SUBL	%EDX,YWAG
	JNS	LOOP32_32_Y	#jump to increment destination row

LOOP32_32_Y2:
	ADDL	SRCSZX,%ESI	#increment source row
	ADDL	SRCSZX,%ESI
	ADDL	SRCSZX,%ESI
	ADDL	SRCSZX,%ESI
	DECL	YCNT		#one more source row processed
	JZ	LOOP32_32_Y3	#all source rows processed?
	MOVL	DSTSZY,%EDX	#put destination weight on 'Waage'
	ADDL	%EDX,YWAG
	JNS	LOOP32_32_Y	#'Waage' still on negative side?
	JMP	LOOP32_32_Y2	# go to draw destination lines again

LOOP32_32_Y3:
	POPL	%EBP		#restore all registers
	POPL	%EDI
	POPL	%ESI
	POPL	%EDX
	POPL	%ECX
	POPL	%EBX
	POPL	%EAX
	RET			#return from routine
render_image_END_32_to_32:


