/**
 * TrueReality - dispatch.h
 * Copyright (C) 1998, 1999 Niki W. Waibel
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 * Information about me (the author):
 *   Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
 *   niki.waibel@gmx.net
**/





#define __DISPATCH_H





#define SHUTDOWN                0x0001
#define MEMORY_ALLOC            0x0002
#define MEMORY_CLEAR            0x0003
#define MEMORY_FREE             0x0004
#define DISPLAY_OPEN            0x0005
#define DISPLAY_INIT            0x0006
#define DISPLAY_REFRESH         0x0007
#define DISPLAY_CLOSE           0x0008
#define CONTROLLER_GET_STATUS   0x0009
#define CONTROLLER_INIT         0x000a
#define CATCH_SIGNALS           0x000b
#define CPU_RESET               0x000c
#define CPU_STOP                0x000d
#define JOYSTICK_OPEN           0x000e
#define JOYSTICK_CLOSE          0x000f
#define AUDIO_OPEN              0x0010
#define AUDIO_CLOSE             0x0011
#define AUDIO_UPDATE            0x0012
#define AUDIO_READY             0x0013
#define CHECK_MACHINE_ENDIAN    0x0014
#define EMU_RESET               0x0015





int     dispatch(int command, void *value);
