/**
 * TrueReality - include/memory_extern.h
 * Copyright (C) 1998, 1999 Niki W. Waibel
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 * Information about me (the author):
 *   Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
 *   niki.waibel@gmx.net
**/





#define __MEMORY_EXTERN_H





#ifndef __TYPE_SIZES_H
#       include "type_sizes.h"
#endif

#ifdef SHM
#       include <X11/Xlib.h>
#       include <X11/extensions/XShm.h>
#endif


struct tr_mem
{
        uBYTE    *rd_ram;
        uBYTE    *sp_dmem;
        uBYTE    *sp_imem;
        uBYTE    *pi_rom;
        uBYTE    *pi_ram;
        uBYTE    *pi_ram_w;

        uBYTE    *rd_reg;
        uBYTE    *sp_reg;
        uBYTE    *dpc_reg;
        uBYTE    *dps_reg;
        uBYTE    *mi_reg;
        uBYTE    *mi_reg_w;
        uBYTE    *vi_reg;
        uBYTE    *ai_reg;
        uBYTE    *pi_reg;
        uBYTE    *pi_reg_w;
        uBYTE    *ri_reg;
        uBYTE    *si_reg;
        uBYTE    *tmem;
        uBYTE    *null_mem;

        uWORD    mi_reg_mode_w;
        uWORD    mi_reg_intr_mask_w;

        uWORD    sp_reg_pc;
        uWORD    sp_reg_ibist;

        uWORD    sp_reg_status_w;

        uWORD    dpc_reg_status_w;

        uWORD    pi_reg_status_w;
};


extern  struct  tr_mem  mem;







#ifdef SHM
        struct tr_shminfo
        {
                XShmSegmentInfo header;
                XShmSegmentInfo bootcode;
                XShmSegmentInfo prgcode;
                
                XShmSegmentInfo rd_ram;
                XShmSegmentInfo sp_dmem;
                XShmSegmentInfo sp_imem;
                XShmSegmentInfo pi_rom;
                XShmSegmentInfo pi_ram;
                XShmSegmentInfo pi_ram_w;

                XShmSegmentInfo rd_reg;
                XShmSegmentInfo sp_reg;
                XShmSegmentInfo dpc_reg;
                XShmSegmentInfo dps_reg;
                XShmSegmentInfo mi_reg;
                XShmSegmentInfo mi_reg_w;
                XShmSegmentInfo vi_reg;
                XShmSegmentInfo ai_reg;
                XShmSegmentInfo pi_reg;
                XShmSegmentInfo pi_reg_w;
                XShmSegmentInfo ri_reg;
                XShmSegmentInfo si_reg;
                XShmSegmentInfo tmem;
                XShmSegmentInfo null_mem;
        };

        extern  struct  tr_shminfo      shminfo;
#endif
