/**
 * TrueReality - include/type_sizes.h
 * Copyright (C) 1998, 1999 Niki W. Waibel
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 * Information about me (the author):
 *   Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
 *   niki.waibel@gmx.net
**/





#ifndef __TYPE_SIZES_H
#define __TYPE_SIZES_H





/*
 *   unsigned types
 *
 */

#ifndef ANSI_64
        typedef unsigned long long      uDWORD;         /* u64 bit */
#endif
        typedef unsigned long           uWORD;          /* u32 bit */
        typedef unsigned short          uHWORD;         /* u16 bit */
#ifdef MACOS
        typedef char                    uBYTE;          /*  u8 bit (mac) */
#else
        typedef unsigned char           uBYTE;          /*  u8 bit */
#endif
        typedef unsigned char           uBIT;           /*  u1 bit */

        typedef unsigned long           uTRIPLEBYTE;    /* u24 bit */
        typedef unsigned long long      uSEPTIBYTE;     /* u56 bit */
        typedef unsigned long long      uSEXTIBYTE;     /* u48 bit */
        typedef unsigned long long      uQUINTIBYTE;    /* u40 bit */



/*
 *   signed types
 *
 */

#ifndef ANSI_64
        typedef signed long long      sDWORD;         /* u64 bit */
#endif
        typedef signed long           sWORD;          /* u32 bit */
        typedef signed short          sHWORD;         /* u16 bit */
        typedef signed char           sBYTE;          /*  u8 bit */
        typedef signed char           sBIT;           /*  u1 bit */

        typedef signed long           sTRIPLEBYTE;    /* u24 bit */
        typedef signed long long      sSEPTIBYTE;     /* u56 bit */
        typedef signed long long      sSEXTIBYTE;     /* u48 bit */
        typedef signed long long      sQUINTIBYTE;    /* u40 bit */





#endif /* #ifndef __TYPE_SIZES_H */

