/**
 * TrueReality - native/functions.c
 * Copyright (C) 1998, 1999 Niki W. Waibel
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 * Information about me (the author):
 *   Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
 *   niki.waibel@gmx.net
**/










#include <stdio.h>

#include <config.h>
#include <ansi_esc_codes.h>
#include <parser_extern.h>

#include "../N64/registers.h"

#ifdef DEBUG
        #include <debug.h>
#endif





void native_nop()
{
}

void native_set_sr()
{
        reg.cpr[0][STATUS] = reg.r[4];

}

void native_get_sr()
{
        reg.r[2] = reg.cpr[0][STATUS];

}

void native_disable_interrupts()
{
        reg.r[2] = reg.cpr[0][STATUS] & 0x0001;
        reg.cpr[0][STATUS] &= 0xfffffffe;

}

void native_restore_interrupts()
{
        reg.cpr[0][STATUS] |= reg.r[4];

}

void native_set_vi_mode()
{
        /* native_disable_interrupts */
        reg.r[2] = reg.cpr[0][STATUS] & 0x0001;
        reg.cpr[0][STATUS] &= 0xfffffffe;

        

        /* native_restore_interrupts */
        reg.cpr[0][STATUS] |= reg.r[4];

}

