/**
 * TrueReality - os/bsd/signal.c
 * Copyright (C) 1998, 1999 Niki W. Waibel
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 * Information about me (the author):
 *   Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
 *   niki.waibel@gmx.net
**/





/**
 *
 * This file is part of the bsd port and comes from:
 * Umu (El Taco) <umuj@yahoo.com>
 *
**/





#include <signal.h>

#include <dispatch.h>
#include <parser_extern.h>

#include "../os.h"
#include "signal.h"





void CatchSignals()
{
        signal(SIGINT,  stop_signal);           /* CTRL+C pressed -> cpu halt -> debugger */
        signal(SIGQUIT, shutdown_signal);
        signal(SIGTERM, shutdown_signal);
#if DISPLAY_SUPPORT
        signal(SIGHUP,  visualkilled_signal);   /* should be sent if display killed */
        signal(SIGPIPE, shutdown_signal);       /* when pipe is broken */
#endif

} /* void CatchSignals() */





void shutdown_signal()
{
        dispatch(SHUTDOWN, 0);

} /* void shutdown_signal() */





void stop_signal()
{
        signal(SIGINT,  SIG_IGN);
        
        dispatch(CPU_STOP, 0);

        signal(SIGINT,  stop_signal);           /* CTRL+C pressed -> cpu halt -> debugger */
        
} /* void shutdown_signal() */







#if DISPLAY_SUPPORT
void visualkilled_signal()
{
        prefs.display = NO_DISPLAY;

} /* void visualkilled_signal() */
#endif












