
// AE.c

#include <AppleEvents.h>
#include <Sound.h>

#include "MacOS.h"
#include "Menu.h"
#include "AE.h"
#include "GameLoad.h"

#include "Display.h"

void InitAppleEvents()
{
	AEEventHandlerUPP theEventHandler;
	
	theEventHandler = NewAEEventHandlerProc( AEoapp );
	AEInstallEventHandler( kCoreEventClass, kAEOpenApplication, theEventHandler, 0, false );
	
	theEventHandler = NewAEEventHandlerProc( AEodoc );
	AEInstallEventHandler( kCoreEventClass, kAEOpenDocuments, theEventHandler, 0, false );
	
	theEventHandler = NewAEEventHandlerProc( AEpdoc );
	AEInstallEventHandler( kCoreEventClass, kAEPrintDocuments, theEventHandler, 0, false );
	
	theEventHandler = NewAEEventHandlerProc( AEquit );
	AEInstallEventHandler( kCoreEventClass, kAEQuitApplication, theEventHandler, 0, false );
}

pascal OSErr AEodoc(AppleEvent* theEvent, AppleEvent* /*theReply*/, long /*refCon*/)
{
	AEDescList	theList;
	AEKeyword	keyWord;
	DescType	type;
	FSSpec		theFile;
	Size		acsize;
	long		n;
	OSErr 		err;
	
	err = AEGetParamDesc (theEvent, keyDirectObject, typeAEList, &theList);
	if(err != noErr) return 0;
	
	err = AECountItems (&theList, &n);
	if (err || n<1) return 0;
	
	if(n>1) SysBeep(1);
	
	err = AEGetNthPtr (&theList, 1, typeFSS, &keyWord, &type,
					   &theFile, sizeof(theFile), &acsize);
	
	if(err == noErr)
	{
		FInfo fileInfo;
		
		FSpGetFInfo( &theFile, &fileInfo );
		if( fileInfo.fdType != 'APPL' )
		{
			OpenRomImage(&theFile);
		}
	}
	
	err = AEDisposeDesc (&theList);
	if(err != noErr) return 0;
	
	return noErr;
}
pascal OSErr AEoapp(AppleEvent* /*theEvent*/, AppleEvent* /*theReply*/, long /*refCon*/)
{
	HandleMenus((mFile << 16) | iOpen);
	
	return noErr;
}

pascal OSErr AEpdoc(AppleEvent* /*theEvent*/, AppleEvent* /*theReply*/, long /*refCon*/)
{
	return errAEEventNotHandled;
}

pascal OSErr AEquit(AppleEvent* /*theEvent*/, AppleEvent* /*theReply*/, long /*refCon*/)
{
	gFinished = true;
	return noErr;
}
