
// Alerts.c

#include "MacOS.h"
#include "StandardDisplay.h"
#include "GameLoad.h"
#include "config.h"
#include <InputSprocket.h>
#include <DrawSprocket.h>
#include "Alerts.h"

#include <string.h>

extern DSpContextReference 	theContext;
extern char gHaltInstrStr[256];

void PreStopAlert()
{
	if (gRunning)
		PauseDisplay();
}

void MyStandardStopAlert(unsigned int type)
{
	unsigned char Str[4][256];
	int i;
	
	PreStopAlert();
	
	for (i = 0; i < 4; i++)
		GetIndString(Str[i], type, i+1);
	
	ParamText(Str[0], Str[1], Str[2], Str[3]);
	Alert(kStopAlert, nil);
}

void MyStandardNumberStopAlert(unsigned int type, OSStatus theError)
{
	unsigned char Str[4][256];
	unsigned char tempStr[256];
	int i;
	
	PreStopAlert();
	
	for (i = 0; i < 4; i++)
		GetIndString(Str[i], type, i+1);
	
	NumToString(theError, tempStr);
	strcat(p2cstr(Str[1]), p2cstr(tempStr));
	c2pstr((char*)Str[1]);
	
	ParamText(Str[0], Str[1], Str[2], Str[3]);
	Alert(kStopAlert, nil);
}

unsigned char gInputSprocketWebAddress[] = "\phttp://til.info.apple.com/swupdates.nsf/artnum/n11167/";

void InputSprocketStopAlert(unsigned int type)
{
	unsigned char Str[4][256];
	unsigned char versionStr[4];
	unsigned char tempStr[8];
	NumVersion version;
	int i;
	
	PreStopAlert();

	for (i = 0; i < 4; i++)
		GetIndString(Str[i], type, i+1);
	
	switch (type)
	{
		case ISpNotAvail:
			ParamText(Str[0], Str[1], Str[2], gInputSprocketWebAddress);
			break;
			
		case ISpTooOld:
			version = ISpGetVersion();
			versionStr[0] = 3;
			versionStr[1] = version.majorRev+'0';
			versionStr[2] = '.';
			versionStr[3] = (version.minorAndBugRev >> 4)+'0';
			
			strcat(p2cstr(Str[1]), p2cstr(versionStr));
			c2pstr((char*)Str[1]);
			ParamText(Str[0], Str[1], Str[2], gInputSprocketWebAddress);
			break;
			
		default:
			NumToString((long)type, tempStr);
			strcat(p2cstr(Str[1]), p2cstr(tempStr));
			c2pstr((char*)Str[1]);
			ParamText(Str[0], Str[1], Str[2], Str[3]);
			break;
	}
	Alert(kStopAlert, nil);
}

short HaltWarning(unsigned int type)
{
	unsigned char Str[4][256];
	int i;
	
	PreStopAlert();
	
	if(!strncmp(gHaltInstrStr, "MEM:", 4))
		type = UnknownMemHalt;

	for (i = 0; i < 4; i++)
		GetIndString(Str[i], type, i+1);

	switch(type)
	{
		case UnknownMemHalt:
			strcpy(p2cstr(Str[2]), (gHaltInstrStr+5));
			c2pstr((char*)Str[2]);
			break;
		case KnownHalt:
			strcpy(p2cstr(Str[2]), gHaltInstrStr);
			c2pstr((char*)Str[2]);
			break;
		case UnknownHalt:
			break;
		default:
			return 1;
	}
	
	ParamText(Str[0], Str[1], Str[2], Str[3]);
	return Alert(kHaltAlert, nil);
}

